from sage.pari.py_pari import pari

###########################################
# Miscellaneou
###########################################
def log(x):
    return x.log()

def vector(n):
    """
    0 vector of length n.
    """
    if n < 0:
        raise ArithmeticError, "Vectors must have nonnegative length."
    return pari("vector(%s)"%n)

###########################################
# 2: CONVERSIONS and similar elementary functions
###########################################

def Col(x): return x.Col()

def List(x):
    return x.List()

def Mat(x):
    return x.Mat()

def Mod(x, y):
    return x.Mod(y)

def Pol(x):
    return x.Pol()

def Polrev(x):
    return x.Polrev()

def Qfb(a, b, c):
    """
        The method notation is awkward, so one can also use functional
        notation.
            >>> Qfb(pari(3), pari(7), pari(2))
            Qfb(3, 7, 2, 0.E-288)
    """
    return a.Qfb(b,c)

def floor(x):
    return x.floor()


###########################################
# 4: NUMBER THEORETICAL functions
###########################################


###########################################
# 5: Functions related to ELLIPTIC CURVES
###########################################
def ellinit(ainvs, flag=0):
    return pari(ainvs).ellinit(flag=flag)

def ellan(e, n):
    return e.ellan(n)

def ellap(e, p):
    return e.ellap(pari(p))
