/* Generated by Pyrex 0.9.3 on Sat Apr  2 16:16:35 2005 */

#include "Python.h"
#include "structmember.h"
#ifndef PY_LONG_LONG
  #define PY_LONG_LONG LONG_LONG
#endif
#include "stdlib.h"
#include "string.h"
#include "setjmp.h"
#include "pari/pari.h"
#include "pari/anal.h"
#include "pari/paripriv.h"


typedef struct {PyObject **p; char *s;} __Pyx_InternTabEntry; /*proto*/
typedef struct {PyObject **p; char *s; long n;} __Pyx_StringTabEntry; /*proto*/
static PyObject *__Pyx_UnpackItem(PyObject *, int); /*proto*/
static int __Pyx_EndUnpack(PyObject *, int); /*proto*/
static int __Pyx_PrintItem(PyObject *); /*proto*/
static int __Pyx_PrintNewline(void); /*proto*/
static void __Pyx_Raise(PyObject *type, PyObject *value, PyObject *tb); /*proto*/
static void __Pyx_ReRaise(void); /*proto*/
static PyObject *__Pyx_Import(PyObject *name, PyObject *from_list); /*proto*/
static PyObject *__Pyx_GetExcValue(void); /*proto*/
static int __Pyx_ArgTypeTest(PyObject *obj, PyTypeObject *type, int none_allowed, char *name); /*proto*/
static int __Pyx_TypeTest(PyObject *obj, PyTypeObject *type); /*proto*/
static int __Pyx_GetStarArgs(PyObject **args, PyObject **kwds, char *kwd_list[], int nargs, PyObject **args2, PyObject **kwds2); /*proto*/
static void __Pyx_WriteUnraisable(char *name); /*proto*/
static void __Pyx_AddTraceback(char *funcname); /*proto*/
static PyTypeObject *__Pyx_ImportType(char *module_name, char *class_name, long size);  /*proto*/
static int __Pyx_SetVtable(PyObject *dict, void *vtable); /*proto*/
static int __Pyx_GetVtable(PyObject *dict, void *vtabptr); /*proto*/
static PyObject *__Pyx_CreateClass(PyObject *bases, PyObject *dict, PyObject *name, char *modname); /*proto*/
static int __Pyx_InternStrings(__Pyx_InternTabEntry *t); /*proto*/
static int __Pyx_InitStrings(__Pyx_StringTabEntry *t); /*proto*/
static PyObject *__Pyx_GetName(PyObject *dict, PyObject *name); /*proto*/

static PyObject *__pyx_m;
static PyObject *__pyx_b;
static int __pyx_lineno;
static char *__pyx_filename;
staticforward char **__pyx_f;

static char __pyx_mdoc[] = "\npy_pari -- Python interface to PARI C-library.\n\nThis module allows you to use Python *instead* of gp, with minimal\nperformance penalty, and all the advantages associated with Python\nbeing a real programming language:\n\n      - Easier memory management:\n            Garbage collection finally!\n            \n            Also, if the \"PARI stack overflows\", then the amount of\n            memory used by PARI is automatically doubled, all the PARI\n            objects are correctly updated, and your computation\n            continues automatically.\n\n      - Exception handling\n      \n      - Class definitions\n      \n      - Object serialization of any PARI object whose string\n        representation evaluates to the object, e.g.,\n            >>> a = pari(5)\n            >>> import pickle\n            >>> s = pickle.dumps(a); \n            >>> z = pickle.loads(s);\n            >>> print z\n            5\n            >>> type(z)\n            <type \'py_pari.gen\'>\n            >>> a == z\n            True\n            >>> a is z\n            False\n\nWARNINGS:\n\n  * Never import this module twice.  Your program will freeze.\n  \n  * PARI commands run at the C-level and cannot be interupted\n    from the Python interpreter with ctrl-C until they are finished.\n    \n";

/* Declarations from py_pari */

staticforward PyTypeObject __pyx_type_7py_pari_gen;

struct __pyx_obj_7py_pari_gen {
  PyObject_HEAD
  struct __pyx_vtabstruct_7py_pari_gen *__pyx_vtab;
  GEN g;
  PyObject *refers_to;
  pari_sp b;
};

struct __pyx_vtabstruct_7py_pari_gen {
  PyObject *((*init)(struct __pyx_obj_7py_pari_gen *,GEN ,pari_sp ));
  GEN ((*_gen)(struct __pyx_obj_7py_pari_gen *));
};
static struct __pyx_vtabstruct_7py_pari_gen *__pyx_vtabptr_7py_pari_gen;

static PyTypeObject *__pyx_ptype_7py_pari_gen = 0;
static int __pyx_v_7py_pari_PREC;
static gp_data __pyx_v_7py_pari___GP_DATA;
static struct __pyx_obj_7py_pari_gen *__pyx_v_7py_pari_ZERO;
static struct __pyx_obj_7py_pari_gen *__pyx_v_7py_pari_ONE;
static struct __pyx_obj_7py_pari_gen *__pyx_v_7py_pari_TWO;
static pari_sp __pyx_v_7py_pari_stack_avma;
static long __pyx_k2;
static unsigned long __pyx_k3;
static PyObject *__pyx_k4;
static long __pyx_k5;
static struct __pyx_obj_7py_pari_gen *__pyx_k6;
static long __pyx_k7;
static PyObject *__pyx_k8;
static PyObject *__pyx_k9;
static PyObject *__pyx_k10;
static PyObject *__pyx_k11;
static PyObject *__pyx_k12;
static long __pyx_k13;
static PyObject *__pyx_k14;
static PyObject *__pyx_k15;
static long __pyx_k16;
static struct __pyx_obj_7py_pari_gen *__pyx_k17;
static long __pyx_k18;
static long __pyx_k19;
static long __pyx_k20;
static struct __pyx_obj_7py_pari_gen *__pyx_k21;
static PyObject *__pyx_k22;
static PyObject *__pyx_k23;
static PyObject *__pyx_k24;
static long __pyx_k25;
static long __pyx_k26;
static long __pyx_k27;
static long __pyx_k28;
static PyObject *__pyx_k29;
static PyObject *__pyx_k30;
static PyObject *__pyx_k31;
static PyObject *__pyx_k33;
static size_t (__pyx_f_7py_pari_fix_size(size_t )); /*proto*/
static int (__pyx_f_7py_pari_init_stack(size_t )); /*proto*/
static GEN (__pyx_f_7py_pari_str_to_GEN(char (*))); /*proto*/
static PyObject *(__pyx_f_7py_pari_GEN_to_str(GEN )); /*proto*/
static PyObject *(__pyx_f_7py_pari_save_avma(void)); /*proto*/
static struct __pyx_obj_7py_pari_gen *(__pyx_f_7py_pari_new_gen(GEN )); /*proto*/
static struct __pyx_obj_7py_pari_gen *(__pyx_f_7py_pari_new_ref(GEN ,struct __pyx_obj_7py_pari_gen *)); /*proto*/

/* Implementation of py_pari */

static char (__pyx_k32[]) = "";

static PyObject *__pyx_n_gc;
static PyObject *__pyx_n_my_sigint;
static PyObject *__pyx_n_initialized;
static PyObject *__pyx_n__max_prime;
static PyObject *__pyx_n_init;
static PyObject *__pyx_n_gens;
static PyObject *__pyx_n_pari;
static PyObject *__pyx_n_stack_pointer;
static PyObject *__pyx_n_stack_top;
static PyObject *__pyx_n_stack_bottom;
static PyObject *__pyx_n_stack_size;
static PyObject *__pyx_n_stack_usage;
static PyObject *__pyx_n_stack_available;
static PyObject *__pyx_n_execute;
static PyObject *__pyx_n_eval;
static PyObject *__pyx_n__error;
static PyObject *__pyx_n_min;
static PyObject *__pyx_n_max;
static PyObject *__pyx_n_nth_prime;
static PyObject *__pyx_n_init_primes;

static PyObject *__pyx_k32p;

static size_t __pyx_f_7py_pari_fix_size(size_t __pyx_v_a) {
  size_t __pyx_v_b;
  size_t __pyx_r;
  int __pyx_1;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":1959 */
  __pyx_v_b = (__pyx_v_a - (__pyx_v_a & (BYTES_IN_LONG - 1)));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":1960 */
  __pyx_1 = (__pyx_v_b < 1024);
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":1961 */
    __pyx_v_b = 1024;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":1962 */
  __pyx_r = __pyx_v_b;
  goto __pyx_L0;

  __pyx_r = 0;
  goto __pyx_L0;
  __pyx_L1:;
  __Pyx_WriteUnraisable("py_pari.fix_size");
  __pyx_L0:;
  return __pyx_r;
}

static PyObject *__pyx_n_MemoryError;

static PyObject *__pyx_k34p;

static char (__pyx_k34[]) = "Unable to allocate %s bytes memory for PARI.";

static int __pyx_f_7py_pari_init_stack(size_t __pyx_v_size) {
  size_t __pyx_v_s;
  int __pyx_r;
  pari_sp __pyx_1;
  int __pyx_2;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  PyObject *__pyx_5 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":1970 */
  __pyx_1 = bot;
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":1972 */
    PyMem_Free(((void (*))bot));
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":1974 */
  __pyx_2 = (__pyx_v_size == 0);
  if (__pyx_2) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":1975 */
    __pyx_v_size = (2 * (top - bot));
    goto __pyx_L3;
  }
  __pyx_L3:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":1978 */
  __pyx_v_s = __pyx_f_7py_pari_fix_size(__pyx_v_size);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":1983 */
  bot = ((pari_sp )PyMem_Malloc(__pyx_v_s));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":1984 */
  __pyx_2 = (!bot);
  if (__pyx_2) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":1985 */
    __pyx_3 = __Pyx_GetName(__pyx_b, __pyx_n_MemoryError); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1985; goto __pyx_L1;}
    __pyx_4 = PyInt_FromLong(((long )__pyx_v_size)); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1985; goto __pyx_L1;}
    __pyx_5 = PyNumber_Remainder(__pyx_k34p, __pyx_4); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1985; goto __pyx_L1;}
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    __Pyx_Raise(__pyx_3, __pyx_5, 0);
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1985; goto __pyx_L1;}
    goto __pyx_L4;
  }
  __pyx_L4:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":1986 */
  top = (bot + __pyx_v_s);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":1987 */
  avma = top;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":1988 */
  __pyx_v_7py_pari_stack_avma = avma;

  __pyx_r = 0;
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  Py_XDECREF(__pyx_5);
  __Pyx_AddTraceback("py_pari.init_stack");
  __pyx_r = -1;
  __pyx_L0:;
  return __pyx_r;
}

static PyObject *__pyx_n_KeyboardInterrupt;

static PyObject *__pyx_f_7py_pari_my_sigint(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_my_sigint(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_signum = 0;
  PyObject *__pyx_v_frame = 0;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {"signum","frame",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "OO", __pyx_argnames, &__pyx_v_signum, &__pyx_v_frame)) return 0;
  Py_INCREF(__pyx_v_signum);
  Py_INCREF(__pyx_v_frame);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":1992 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_KeyboardInterrupt); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1992; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1992; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.my_sigint");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_signum);
  Py_DECREF(__pyx_v_frame);
  return __pyx_r;
}

static PyObject *__pyx_n_RuntimeError;
static PyObject *__pyx_n_signal;
static PyObject *__pyx_n_SIGINT;

static PyObject *__pyx_k35p;

static char (__pyx_k35[]) = "pari_init has already been called.";

static PyObject *__pyx_f_7py_pari_init(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_init[] = "\n    Initialize the PARI system.\n    \n    INPUT:\n        size -- long, the number of bytes for the initial PARI stack\n                (see note below)\n        maxprime -- unsigned long, upper limit on a precomputed prime\n                    number table  (default: 2000000)\n\n    NOTES:\n    \n        * In py_pari, the PARI stack is different than in gp or the\n          PARI C library.  In Python, instead of the PARI stack\n          holding the results of all computations, it *only* holds the\n          results of an individual computation.  Each time a new\n          Python/PARI object is computed, it it copied to its own\n          space in the Python heap, and the memory it occupied on the\n          PARI stack is freed.  Thus it is not necessary to make the\n          stack very large.  Also, unlike in PARI, if the stack does\n          overflow, in most cases the PARI stack is automatically\n          increased and the relevant step of the computation rerun.\n\n          This design obviously involves some performance penalties\n          over the way PARI works, but it scales much better and is\n          far more robus for large projects.\n          \n        * If you do not want prime numbers, put maxprime=2, but be\n          careful because many PARI functions require this table.  If\n          you get the error message \"not enough precomputed primes\",\n          increase this parameter.\n          \n    ";
static PyObject *__pyx_f_7py_pari_init(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  long __pyx_v_size;
  unsigned long __pyx_v_maxprime;
  PyObject *__pyx_v_signal;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  int __pyx_2;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  PyObject *__pyx_5 = 0;
  static char *__pyx_argnames[] = {"size","maxprime",0};
  __pyx_v_size = __pyx_k2;
  __pyx_v_maxprime = __pyx_k3;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|ll", __pyx_argnames, &__pyx_v_size, &__pyx_v_maxprime)) return 0;
  __pyx_v_signal = Py_None; Py_INCREF(__pyx_v_signal);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2033 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_initialized); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2033; goto __pyx_L1;}
  __pyx_2 = PyObject_IsTrue(__pyx_1); if (__pyx_2 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2033; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  if (__pyx_2) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2034 */
    __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_RuntimeError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2034; goto __pyx_L1;}
    __Pyx_Raise(__pyx_1, __pyx_k35p, 0);
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2034; goto __pyx_L1;}
    goto __pyx_L2;
  }
  /*else*/ {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2038 */
    pari_init(1,__pyx_v_maxprime);

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2039 */
    __pyx_2 = __pyx_f_7py_pari_init_stack(__pyx_v_size); if (__pyx_2 == -1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2039; goto __pyx_L1;}

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2040 */
    __pyx_1 = __Pyx_Import(__pyx_n_signal, 0); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2040; goto __pyx_L1;}
    Py_DECREF(__pyx_v_signal);
    __pyx_v_signal = __pyx_1;
    __pyx_1 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2041 */
    __pyx_1 = PyObject_GetAttr(__pyx_v_signal, __pyx_n_signal); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2041; goto __pyx_L1;}
    __pyx_3 = PyObject_GetAttr(__pyx_v_signal, __pyx_n_SIGINT); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2041; goto __pyx_L1;}
    __pyx_4 = __Pyx_GetName(__pyx_m, __pyx_n_my_sigint); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2041; goto __pyx_L1;}
    __pyx_5 = PyTuple_New(2); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2041; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_5, 0, __pyx_3);
    PyTuple_SET_ITEM(__pyx_5, 1, __pyx_4);
    __pyx_3 = 0;
    __pyx_4 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_5); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2041; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2042 */
    __pyx_4 = PyInt_FromLong(1); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2042; goto __pyx_L1;}
    if (PyObject_SetAttr(__pyx_m, __pyx_n_initialized, __pyx_4) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2042; goto __pyx_L1;}
    Py_DECREF(__pyx_4); __pyx_4 = 0;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2043 */
  __pyx_1 = PyLong_FromUnsignedLong(__pyx_v_maxprime); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2043; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n__max_prime, __pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2043; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  Py_XDECREF(__pyx_5);
  __Pyx_AddTraceback("py_pari.init");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_signal);
  return __pyx_r;
}

static GEN __pyx_f_7py_pari_str_to_GEN(char (*__pyx_v_s)) {
  int __pyx_v_n;
  GEN __pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  PyObject *__pyx_5 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2059 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2060 */
  __pyx_1 = __pyx_v_n;
  if (__pyx_1) {
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2060; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2060; goto __pyx_L1;}
    __pyx_4 = PyString_FromString(__pyx_v_s); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2060; goto __pyx_L1;}
    __pyx_5 = PyTuple_New(2); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2060; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_5, 0, __pyx_3);
    PyTuple_SET_ITEM(__pyx_5, 1, __pyx_4);
    __pyx_3 = 0;
    __pyx_4 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_5); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2060; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2061 */
  __pyx_r = flisseq(__pyx_v_s);
  goto __pyx_L0;

  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  Py_XDECREF(__pyx_5);
  __Pyx_AddTraceback("py_pari.str_to_GEN");
  __pyx_r = 0;
  __pyx_L0:;
  return __pyx_r;
}

static PyObject *__pyx_n_str;

static PyObject *__pyx_k37p;

static char (__pyx_k37[]) = "converting a gen to a string";

static PyObject *__pyx_f_7py_pari_GEN_to_str(GEN __pyx_v_g) {
  char (*__pyx_v_c);
  int __pyx_v_n;
  PyObject *__pyx_v_s;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  __pyx_v_s = Py_None; Py_INCREF(__pyx_v_s);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2066 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2067 */
  __pyx_1 = __pyx_v_n;
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2068 */
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2068; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2068; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2068; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    Py_INCREF(__pyx_k37p);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k37p);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2068; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2069 */
  __pyx_v_c = GENtostr(__pyx_v_g);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2070 */
  __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_str); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2070; goto __pyx_L1;}
  __pyx_4 = PyString_FromString(__pyx_v_c); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2070; goto __pyx_L1;}
  __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2070; goto __pyx_L1;}
  PyTuple_SET_ITEM(__pyx_3, 0, __pyx_4);
  __pyx_4 = 0;
  __pyx_4 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2070; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  Py_DECREF(__pyx_v_s);
  __pyx_v_s = __pyx_4;
  __pyx_4 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2071 */
  free(__pyx_v_c);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2072 */
  Py_INCREF(__pyx_v_s);
  __pyx_r = __pyx_v_s;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari.GEN_to_str");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_s);
  return __pyx_r;
}

static char (__pyx_k38[]) = "\n            g -- PARI GEN\n            b -- pointer to memory chunk where PARI gen lives\n                 (if nonzero then this memory is freed when the object\n                  goes out of scope)\n        ";

static PyObject *__pyx_f_7py_pari_3gen_init(struct __pyx_obj_7py_pari_gen *__pyx_v_self,GEN __pyx_v_g,pari_sp __pyx_v_b) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2091 */
  __pyx_k38;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2097 */
  __pyx_v_self->g = __pyx_v_g;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2098 */
  __pyx_v_self->b = __pyx_v_b;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2099 */
  __pyx_1 = PyDict_New(); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2099; goto __pyx_L1;}
  Py_DECREF(__pyx_v_self->refers_to);
  __pyx_v_self->refers_to = __pyx_1;
  __pyx_1 = 0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.init");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static void __pyx_f_7py_pari_3gen___dealloc__(PyObject *__pyx_v_self); /*proto*/
static void __pyx_f_7py_pari_3gen___dealloc__(PyObject *__pyx_v_self) {
  pari_sp __pyx_1;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2102 */
  __pyx_1 = ((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->b;
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2104 */
    PyMem_Free(((void (*))((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->b));
    goto __pyx_L2;
  }
  __pyx_L2:;

  goto __pyx_L0;
  __pyx_L1:;
  __Pyx_AddTraceback("py_pari.gen.__dealloc__");
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
}

static PyObject *__pyx_f_7py_pari_3gen___repr__(PyObject *__pyx_v_self); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen___repr__(PyObject *__pyx_v_self) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2107 */
  __pyx_1 = __pyx_f_7py_pari_GEN_to_str(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2107; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.__repr__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static GEN __pyx_f_7py_pari_3gen__gen(struct __pyx_obj_7py_pari_gen *__pyx_v_self) {
  GEN __pyx_r;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2110 */
  __pyx_r = __pyx_v_self->g;
  goto __pyx_L0;

  goto __pyx_L0;
  __pyx_L1:;
  __Pyx_WriteUnraisable("py_pari.gen._gen");
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_n_py_pari_py;

static PyObject *__pyx_k39p;

static char (__pyx_k39[]) = "sage.pari.py_pari_py";

static PyObject *__pyx_f_7py_pari_3gen___reduce__(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen___reduce__(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_z;
  PyObject *__pyx_v_sage;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_self);
  __pyx_v_z = Py_None; Py_INCREF(__pyx_v_z);
  __pyx_v_sage = Py_None; Py_INCREF(__pyx_v_sage);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2113 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_str); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2113; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2113; goto __pyx_L1;}
  Py_INCREF(__pyx_v_self);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_self);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2113; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_v_z);
  __pyx_v_z = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2114 */
  __pyx_1 = __Pyx_Import(__pyx_k39p, 0); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2114; goto __pyx_L1;}
  Py_DECREF(__pyx_v_sage);
  __pyx_v_sage = __pyx_1;
  __pyx_1 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2115 */
  __pyx_2 = PyObject_GetAttr(__pyx_v_sage, __pyx_n_pari); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2115; goto __pyx_L1;}
  __pyx_3 = PyObject_GetAttr(__pyx_2, __pyx_n_py_pari_py); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2115; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  __pyx_1 = PyObject_GetAttr(__pyx_3, __pyx_n_pari); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2115; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2115; goto __pyx_L1;}
  Py_INCREF(__pyx_v_z);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_z);
  __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2115; goto __pyx_L1;}
  PyTuple_SET_ITEM(__pyx_3, 0, __pyx_1);
  PyTuple_SET_ITEM(__pyx_3, 1, __pyx_2);
  __pyx_1 = 0;
  __pyx_2 = 0;
  __pyx_r = __pyx_3;
  __pyx_3 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.__reduce__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_z);
  Py_DECREF(__pyx_v_sage);
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen___add__(PyObject *__pyx_v_self, PyObject *__pyx_v_other); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen___add__(PyObject *__pyx_v_self, PyObject *__pyx_v_other) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_other);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_self), __pyx_ptype_7py_pari_gen, 1, "self")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2121; goto __pyx_L1;}
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_other), __pyx_ptype_7py_pari_gen, 1, "other")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2121; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2122 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(gadd(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g),((struct __pyx_obj_7py_pari_gen *)__pyx_v_other)->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2122; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.__add__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_other);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen___sub__(PyObject *__pyx_v_self, PyObject *__pyx_v_other); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen___sub__(PyObject *__pyx_v_self, PyObject *__pyx_v_other) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_other);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_self), __pyx_ptype_7py_pari_gen, 1, "self")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2124; goto __pyx_L1;}
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_other), __pyx_ptype_7py_pari_gen, 1, "other")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2124; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2125 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(gsub(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g,((struct __pyx_obj_7py_pari_gen *)__pyx_v_other)->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2125; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.__sub__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_other);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen___mul__(PyObject *__pyx_v_self, PyObject *__pyx_v_other); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen___mul__(PyObject *__pyx_v_self, PyObject *__pyx_v_other) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_other);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_self), __pyx_ptype_7py_pari_gen, 1, "self")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2127; goto __pyx_L1;}
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_other), __pyx_ptype_7py_pari_gen, 1, "other")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2127; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2128 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(gmul(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g),((struct __pyx_obj_7py_pari_gen *)__pyx_v_other)->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2128; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.__mul__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_other);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen___div__(PyObject *__pyx_v_self, PyObject *__pyx_v_other); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen___div__(PyObject *__pyx_v_self, PyObject *__pyx_v_other) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_other);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_self), __pyx_ptype_7py_pari_gen, 1, "self")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2130; goto __pyx_L1;}
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_other), __pyx_ptype_7py_pari_gen, 1, "other")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2130; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2131 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(gdiv(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g),forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_other)->g)))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2131; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.__div__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_other);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen___neg__(PyObject *__pyx_v_self); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen___neg__(PyObject *__pyx_v_self) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2134 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(gneg(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2134; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.__neg__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen___mod__(PyObject *__pyx_v_self, PyObject *__pyx_v_other); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen___mod__(PyObject *__pyx_v_self, PyObject *__pyx_v_other) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_other);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_self), __pyx_ptype_7py_pari_gen, 1, "self")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2136; goto __pyx_L1;}
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_other), __pyx_ptype_7py_pari_gen, 1, "other")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2136; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2137 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(gmod(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g),((struct __pyx_obj_7py_pari_gen *)__pyx_v_other)->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2137; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.__mod__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_other);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen___pow__(PyObject *__pyx_v_self, PyObject *__pyx_arg_n, PyObject *__pyx_v_m); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen___pow__(PyObject *__pyx_v_self, PyObject *__pyx_arg_n, PyObject *__pyx_v_m) {
  long __pyx_v_n;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_m);
  __pyx_v_n = PyInt_AsLong(__pyx_arg_n); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2139; goto __pyx_L1;}
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_self), __pyx_ptype_7py_pari_gen, 1, "self")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2139; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2140 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(gpowgs(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g),__pyx_v_n))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2140; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.__pow__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_m);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen___rshift__(PyObject *__pyx_v_self, PyObject *__pyx_arg_n); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen___rshift__(PyObject *__pyx_v_self, PyObject *__pyx_arg_n) {
  long __pyx_v_n;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  Py_INCREF(__pyx_v_self);
  __pyx_v_n = PyInt_AsLong(__pyx_arg_n); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2142; goto __pyx_L1;}
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_self), __pyx_ptype_7py_pari_gen, 1, "self")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2142; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2143 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(ishiftr(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g),__pyx_v_n))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2143; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.__rshift__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen___lshift__(PyObject *__pyx_v_self, PyObject *__pyx_arg_n); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen___lshift__(PyObject *__pyx_v_self, PyObject *__pyx_arg_n) {
  long __pyx_v_n;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  Py_INCREF(__pyx_v_self);
  __pyx_v_n = PyInt_AsLong(__pyx_arg_n); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2145; goto __pyx_L1;}
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_self), __pyx_ptype_7py_pari_gen, 1, "self")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2145; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2146 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(gshift(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g),__pyx_v_n))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2146; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.__lshift__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen___invert__(PyObject *__pyx_v_self); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen___invert__(PyObject *__pyx_v_self) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2149 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(ginv(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g)))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2149; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.__invert__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_n_IndexError;

static PyObject *__pyx_k40p;

static char (__pyx_k40[]) = "index (%s) must be between 0 and %s";

static PyObject *__pyx_f_7py_pari_3gen___getitem__(PyObject *__pyx_v_self, PyObject *__pyx_arg_n); /*proto*/
static char __pyx_doc_7py_pari_3gen___getitem__[] = "\n        Return a *copy* of the nth entry.\n\n        The indexing is 0-based, like in Python.  However, *copying*\n        the nth entry instead of returning reference is different\n        than what one usually does in Python.  However, we do it\n        this way for consistency with the PARI/GP interpreter, which\n        does make copies.\n        ";
static PyObject *__pyx_f_7py_pari_3gen___getitem__(PyObject *__pyx_v_self, PyObject *__pyx_arg_n) {
  long __pyx_v_n;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  PyObject *__pyx_5 = 0;
  Py_INCREF(__pyx_v_self);
  __pyx_v_n = PyInt_AsLong(__pyx_arg_n); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2154; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2164 */
  __pyx_1 = (__pyx_v_n < 0);
  if (!__pyx_1) {
    __pyx_1 = (__pyx_v_n >= glength(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g));
  }
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2165 */
    __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_IndexError); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2165; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2165; goto __pyx_L1;}
    __pyx_4 = PyInt_FromLong((glength(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g) - 1)); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2165; goto __pyx_L1;}
    __pyx_5 = PyTuple_New(2); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2165; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_5, 0, __pyx_3);
    PyTuple_SET_ITEM(__pyx_5, 1, __pyx_4);
    __pyx_3 = 0;
    __pyx_4 = 0;
    __pyx_3 = PyNumber_Remainder(__pyx_k40p, __pyx_5); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2165; goto __pyx_L1;}
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    __Pyx_Raise(__pyx_2, __pyx_3, 0);
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2165; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2166 */
  __pyx_4 = ((PyObject *)__pyx_f_7py_pari_new_ref(((GEN )(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g[(__pyx_v_n + 1)])),((struct __pyx_obj_7py_pari_gen *)__pyx_v_self))); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2166; goto __pyx_L1;}
  __pyx_r = __pyx_4;
  __pyx_4 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  Py_XDECREF(__pyx_5);
  __Pyx_AddTraceback("py_pari.gen.__getitem__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_n_NotImplementedError;

static PyObject *__pyx_f_7py_pari_3gen___getslice__(PyObject *__pyx_v_self, int __pyx_arg_i, int __pyx_arg_j); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen___getslice__(PyObject *__pyx_v_self, int __pyx_arg_i, int __pyx_arg_j) {
  PyObject *__pyx_v_i = 0;
  PyObject *__pyx_v_j = 0;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  Py_INCREF(__pyx_v_self);
  __pyx_v_i = PyInt_FromLong(__pyx_arg_i); if (!__pyx_v_i) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2169; goto __pyx_L1;}
  __pyx_v_j = PyInt_FromLong(__pyx_arg_j); if (!__pyx_v_j) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2169; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2170 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2170; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2170; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.__getslice__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_i);
  Py_DECREF(__pyx_v_j);
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_k41p;

static char (__pyx_k41[]) = "index (%s) must be between 0 and %s";

static int __pyx_f_7py_pari_3gen___setitem__(PyObject *__pyx_v_self, PyObject *__pyx_arg_n, PyObject *__pyx_v_x); /*proto*/
static char __pyx_doc_7py_pari_3gen___setitem__[] = "\n        Set the nth entry to a *copy* of x.  \n        \n        The indexing is 0-based, like in Python.  However, setting\n        the nth entry to a *copy* instead of a reference is different\n        than what one usually does in Python.  However, we do it\n        this way for consistency with the PARI/GP interpreter, which\n        does make copies.\n        ";
static int __pyx_f_7py_pari_3gen___setitem__(PyObject *__pyx_v_self, PyObject *__pyx_arg_n, PyObject *__pyx_v_x) {
  long __pyx_v_n;
  struct __pyx_obj_7py_pari_gen *__pyx_v_c;
  int __pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  PyObject *__pyx_5 = 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_x);
  __pyx_v_n = PyInt_AsLong(__pyx_arg_n); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2172; goto __pyx_L1;}
  ((PyObject*)__pyx_v_c) = Py_None; Py_INCREF(((PyObject*)__pyx_v_c));
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_x), __pyx_ptype_7py_pari_gen, 1, "x")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2172; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2183 */
  __pyx_1 = (__pyx_v_n < 0);
  if (!__pyx_1) {
    __pyx_1 = (__pyx_v_n >= glength(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g));
  }
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2184 */
    __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_IndexError); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2184; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2184; goto __pyx_L1;}
    __pyx_4 = PyInt_FromLong((glength(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g) - 1)); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2184; goto __pyx_L1;}
    __pyx_5 = PyTuple_New(2); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2184; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_5, 0, __pyx_3);
    PyTuple_SET_ITEM(__pyx_5, 1, __pyx_4);
    __pyx_3 = 0;
    __pyx_4 = 0;
    __pyx_3 = PyNumber_Remainder(__pyx_k41p, __pyx_5); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2184; goto __pyx_L1;}
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    __Pyx_Raise(__pyx_2, __pyx_3, 0);
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2184; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2186 */
  __pyx_4 = PyInt_FromLong(__pyx_v_n); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2186; goto __pyx_L1;}
  if (PyObject_SetItem(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->refers_to, __pyx_4, __pyx_v_x) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2186; goto __pyx_L1;}
  Py_DECREF(__pyx_4); __pyx_4 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2189 */
  (((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g[(__pyx_v_n + 1)]) = ((long )((struct __pyx_obj_7py_pari_gen *)__pyx_v_x)->g);

  __pyx_r = 0;
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  Py_XDECREF(__pyx_5);
  __Pyx_AddTraceback("py_pari.gen.__setitem__");
  __pyx_r = -1;
  __pyx_L0:;
  Py_DECREF(__pyx_v_c);
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static int __pyx_f_7py_pari_3gen___len__(PyObject *__pyx_v_self); /*proto*/
static int __pyx_f_7py_pari_3gen___len__(PyObject *__pyx_v_self) {
  int __pyx_r;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2192 */
  __pyx_r = glength(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g);
  goto __pyx_L0;

  __pyx_r = 0;
  goto __pyx_L0;
  __pyx_L1:;
  __Pyx_AddTraceback("py_pari.gen.__len__");
  __pyx_r = -1;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static int __pyx_f_7py_pari_3gen___cmp__(PyObject *__pyx_v_self, PyObject *__pyx_v_other); /*proto*/
static int __pyx_f_7py_pari_3gen___cmp__(PyObject *__pyx_v_self, PyObject *__pyx_v_other) {
  int __pyx_r;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_other);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_other), __pyx_ptype_7py_pari_gen, 1, "other")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2199; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2200 */
  __pyx_r = gcmp(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g,((struct __pyx_obj_7py_pari_gen *)__pyx_v_other)->g);
  goto __pyx_L0;

  __pyx_r = 0;
  goto __pyx_L0;
  __pyx_L1:;
  __Pyx_AddTraceback("py_pari.gen.__cmp__");
  __pyx_r = -1;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_other);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_copy(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_copy(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2203 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(gcopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2203; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.copy");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_eval(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_eval(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2212 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_eval); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2212; goto __pyx_L1;}
  __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_str); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2212; goto __pyx_L1;}
  __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2212; goto __pyx_L1;}
  Py_INCREF(__pyx_v_self);
  PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_self);
  __pyx_4 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2212; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2212; goto __pyx_L1;}
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_4);
  __pyx_4 = 0;
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2212; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  __pyx_r = __pyx_3;
  __pyx_3 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari.gen.eval");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_n_replace;
static PyObject *__pyx_n_find;

static PyObject *__pyx_k42p;
static PyObject *__pyx_k43p;
static PyObject *__pyx_k44p;
static PyObject *__pyx_k45p;
static PyObject *__pyx_k46p;
static PyObject *__pyx_k47p;
static PyObject *__pyx_k48p;
static PyObject *__pyx_k49p;
static PyObject *__pyx_k50p;
static PyObject *__pyx_k51p;

static char (__pyx_k42[]) = "Mat(";
static char (__pyx_k43[]) = "[";
static char (__pyx_k44[]) = "]";
static char (__pyx_k45[]) = "~";
static char (__pyx_k46[]) = "";
static char (__pyx_k47[]) = ";";
static char (__pyx_k48[]) = ";";
static char (__pyx_k49[]) = "], [";
static char (__pyx_k50[]) = "[";
static char (__pyx_k51[]) = "]";

static PyObject *__pyx_f_7py_pari_3gen_list(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_list(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_s;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  int __pyx_4;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_self);
  __pyx_v_s = Py_None; Py_INCREF(__pyx_v_s);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2215 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_str); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2215; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2215; goto __pyx_L1;}
  Py_INCREF(__pyx_v_self);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_self);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2215; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_v_s);
  __pyx_v_s = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2216 */
  __pyx_1 = PySequence_GetSlice(__pyx_v_s, 0, 4); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2216; goto __pyx_L1;}
  if (PyObject_Cmp(__pyx_1, __pyx_k42p, &__pyx_4) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2216; goto __pyx_L1;}
  __pyx_4 = __pyx_4 == 0;
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  if (__pyx_4) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2217 */
    __pyx_2 = PySequence_GetSlice(__pyx_v_s, 4, (-1)); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2217; goto __pyx_L1;}
    __pyx_3 = PyNumber_Add(__pyx_k43p, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2217; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    __pyx_1 = PyNumber_Add(__pyx_3, __pyx_k44p); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2217; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_v_s);
    __pyx_v_s = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2218 */
  __pyx_2 = PyObject_GetAttr(__pyx_v_s, __pyx_n_replace); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2218; goto __pyx_L1;}
  __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2218; goto __pyx_L1;}
  Py_INCREF(__pyx_k45p);
  PyTuple_SET_ITEM(__pyx_3, 0, __pyx_k45p);
  Py_INCREF(__pyx_k46p);
  PyTuple_SET_ITEM(__pyx_3, 1, __pyx_k46p);
  __pyx_1 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2218; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  Py_DECREF(__pyx_v_s);
  __pyx_v_s = __pyx_1;
  __pyx_1 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2219 */
  __pyx_2 = PyObject_GetAttr(__pyx_v_s, __pyx_n_find); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2219; goto __pyx_L1;}
  __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2219; goto __pyx_L1;}
  Py_INCREF(__pyx_k47p);
  PyTuple_SET_ITEM(__pyx_3, 0, __pyx_k47p);
  __pyx_1 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2219; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  __pyx_2 = PyInt_FromLong((-1)); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2219; goto __pyx_L1;}
  if (PyObject_Cmp(__pyx_1, __pyx_2, &__pyx_4) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2219; goto __pyx_L1;}
  __pyx_4 = __pyx_4 != 0;
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (__pyx_4) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2220 */
    __pyx_3 = PyObject_GetAttr(__pyx_v_s, __pyx_n_replace); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2220; goto __pyx_L1;}
    __pyx_1 = PyTuple_New(2); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2220; goto __pyx_L1;}
    Py_INCREF(__pyx_k48p);
    PyTuple_SET_ITEM(__pyx_1, 0, __pyx_k48p);
    Py_INCREF(__pyx_k49p);
    PyTuple_SET_ITEM(__pyx_1, 1, __pyx_k49p);
    __pyx_2 = PyObject_CallObject(__pyx_3, __pyx_1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2220; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_v_s);
    __pyx_v_s = __pyx_2;
    __pyx_2 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2221 */
    __pyx_3 = PyNumber_Add(__pyx_k50p, __pyx_v_s); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2221; goto __pyx_L1;}
    __pyx_1 = PyNumber_Add(__pyx_3, __pyx_k51p); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2221; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_v_s);
    __pyx_v_s = __pyx_1;
    __pyx_1 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2222 */
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_eval); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2222; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2222; goto __pyx_L1;}
    Py_INCREF(__pyx_v_s);
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_s);
    __pyx_1 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2222; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;
    goto __pyx_L3;
  }
  /*else*/ {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2224 */
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_eval); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2224; goto __pyx_L1;}
    __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2224; goto __pyx_L1;}
    Py_INCREF(__pyx_v_s);
    PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_s);
    __pyx_1 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2224; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __pyx_r = __pyx_1;
    __pyx_1 = 0;
    goto __pyx_L0;
  }
  __pyx_L3:;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.list");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_s);
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen___int__(PyObject *__pyx_v_self); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen___int__(PyObject *__pyx_v_self) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2228 */
  __pyx_1 = PyInt_FromLong(gtolong(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2228; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.__int__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_n_long;

static PyObject *__pyx_f_7py_pari_3gen___long__(PyObject *__pyx_v_self); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen___long__(PyObject *__pyx_v_self) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2231 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_long); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2231; goto __pyx_L1;}
  __pyx_2 = __pyx_f_7py_pari_GEN_to_str(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2231; goto __pyx_L1;}
  __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2231; goto __pyx_L1;}
  PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
  __pyx_2 = 0;
  __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2231; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.__long__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen___float__(PyObject *__pyx_v_self); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen___float__(PyObject *__pyx_v_self) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2235 */
  __pyx_1 = PyFloat_FromDouble(gtodouble(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2235; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.__float__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_isprime(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_isprime[] = "\n        isprime(x, flag=0): Returns true (1) if x is a PROVEN prime\n        number, and false (0) otherwise. \n\n        INPUT:\n            flag -- int \n                    0 (default): use a combination of algorithms.\n                    1: certify primality using the Pocklington-Lehmer Test.\n                    2: certify primality using the APRCL test.\n        OUTPUT:\n            gen -- 0 or 1\n        ";
static PyObject *__pyx_f_7py_pari_3gen_isprime(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_flag = 0;
  PyObject *__pyx_r;
  long __pyx_1;
  PyObject *__pyx_2 = 0;
  static char *__pyx_argnames[] = {"flag",0};
  __pyx_v_flag = __pyx_k4;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|O", __pyx_argnames, &__pyx_v_flag)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_flag);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2254 */
  __pyx_1 = PyInt_AsLong(__pyx_v_flag); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2254; goto __pyx_L1;}
  __pyx_2 = ((PyObject *)__pyx_f_7py_pari_new_gen(gisprime(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g,__pyx_1))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2254; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("py_pari.gen.isprime");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_flag);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_divrem(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_divrem[] = "\n        divrem(x, y, long v): Euclidean division of x by y giving as a\n        2-dimensional column vector the quotient and the remainder,\n        with respect to v (to main variable if v is omitted).\n        ";
static PyObject *__pyx_f_7py_pari_3gen_divrem(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  struct __pyx_obj_7py_pari_gen *__pyx_v_y = 0;
  long __pyx_v_v;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {"y","v",0};
  __pyx_v_v = __pyx_k5;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O|l", __pyx_argnames, &__pyx_v_y, &__pyx_v_v)) return 0;
  Py_INCREF(__pyx_v_x);
  Py_INCREF(__pyx_v_y);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_y), __pyx_ptype_7py_pari_gen, 1, "y")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2260; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2266 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(divrem(((struct __pyx_obj_7py_pari_gen *)__pyx_v_x)->g,__pyx_v_y->g,__pyx_v_v))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2266; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.divrem");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  Py_DECREF(__pyx_v_y);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_lex(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_lex[] = "\n        lex(x,y): Compare x and y lexicographically (1 if x>y, 0 if x==y, -1 if x<y)\n        ";
static PyObject *__pyx_f_7py_pari_3gen_lex(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  struct __pyx_obj_7py_pari_gen *__pyx_v_y = 0;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {"y",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_y)) return 0;
  Py_INCREF(__pyx_v_x);
  Py_INCREF(__pyx_v_y);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_y), __pyx_ptype_7py_pari_gen, 1, "y")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2268; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2272 */
  __pyx_1 = PyInt_FromLong(lexcmp(((struct __pyx_obj_7py_pari_gen *)__pyx_v_x)->g,__pyx_v_y->g)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2272; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.lex");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  Py_DECREF(__pyx_v_y);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_max(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_max[] = "\n        max(x,y): Return the maximum of x and y.\n        ";
static PyObject *__pyx_f_7py_pari_3gen_max(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  struct __pyx_obj_7py_pari_gen *__pyx_v_y = 0;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {"y",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_y)) return 0;
  Py_INCREF(__pyx_v_x);
  Py_INCREF(__pyx_v_y);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_y), __pyx_ptype_7py_pari_gen, 1, "y")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2274; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2278 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(gmax(((struct __pyx_obj_7py_pari_gen *)__pyx_v_x)->g,__pyx_v_y->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2278; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.max");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  Py_DECREF(__pyx_v_y);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_min(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_min[] = "\n        min(x,y): Return the minumum of x and y.\n        ";
static PyObject *__pyx_f_7py_pari_3gen_min(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  struct __pyx_obj_7py_pari_gen *__pyx_v_y = 0;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {"y",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_y)) return 0;
  Py_INCREF(__pyx_v_x);
  Py_INCREF(__pyx_v_y);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_y), __pyx_ptype_7py_pari_gen, 1, "y")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2280; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2284 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(gmin(((struct __pyx_obj_7py_pari_gen *)__pyx_v_x)->g,__pyx_v_y->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2284; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.min");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  Py_DECREF(__pyx_v_y);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_shift(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_shift[] = "\n        shift(x,n): shift x left n bits if n>=0, right -n bits if n<0.\n        ";
static PyObject *__pyx_f_7py_pari_3gen_shift(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  long __pyx_v_n;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {"n",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "l", __pyx_argnames, &__pyx_v_n)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2290 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(gshift(((struct __pyx_obj_7py_pari_gen *)__pyx_v_x)->g,__pyx_v_n))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2290; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.shift");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_shiftmul(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_shiftmul[] = "\n        shiftmul(x,n): Return the product of x by 2^n (n>=0 or n<0).\n        ";
static PyObject *__pyx_f_7py_pari_3gen_shiftmul(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  long __pyx_v_n;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {"n",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "l", __pyx_argnames, &__pyx_v_n)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2296 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(gmul2n(((struct __pyx_obj_7py_pari_gen *)__pyx_v_x)->g,__pyx_v_n))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2296; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.shiftmul");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_sign(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_sign[] = "\n        sign(x): Return the sign of x, where x is of type integer, real\n        or fraction.\n        ";
static PyObject *__pyx_f_7py_pari_3gen_sign(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2303 */
  __pyx_1 = PyInt_FromLong(gsigne(((struct __pyx_obj_7py_pari_gen *)__pyx_v_x)->g)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2303; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.sign");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_vecmax(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_vecmax[] = "\n        vecmax(x): Return the maximum of the elements of the vector/matrix x,\n        ";
static PyObject *__pyx_f_7py_pari_3gen_vecmax(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2309 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(vecmax(((struct __pyx_obj_7py_pari_gen *)__pyx_v_x)->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2309; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.vecmax");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_vecmin(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_vecmin[] = "\n        vecmin(x): Return the maximum of the elements of the vector/matrix x,\n        ";
static PyObject *__pyx_f_7py_pari_3gen_vecmin(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2316 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(vecmin(((struct __pyx_obj_7py_pari_gen *)__pyx_v_x)->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2316; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.vecmin");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_Col(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_Col[] = "\n        Col(x): Transforms the object x into a column vector. \n        ";
static PyObject *__pyx_f_7py_pari_3gen_Col(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2331 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2331; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2331; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.Col");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_List(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_List[] = "\n        List(x): transforms the PARI vector or list x into a list.\n\n        EXAMPLES:\n            >>> v = pari([1,2,3])\n            >>> v\n            [1, 2, 3]\n            >>> v.type()\n            \'t_VEC\'\n            >>> w = v.List()\n            >>> w\n            List([1, 2, 3])\n            >>> w.type()\n            \'t_LIST\'\n        ";
static PyObject *__pyx_f_7py_pari_3gen_List(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2349 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(gtolist(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_x)->g)))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2349; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.List");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_Mat(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_Mat[] = "\n        Mat(x): transforms any PARI x into a matrix.\n\n        EXAMPLES:\n            >>> x = pari(5)\n            >>> x.type()\n            \'t_INT\'\n            >>> y = x.Mat()\n            >>> y\n            Mat(5)\n            >>> y.type()\n            \'t_MAT\'\n            >>> x = pari(\'[1,2;3,4]\')\n            >>> x.type()\n            \'t_MAT\'\n            >>> x = pari(\'[1,2,3,4]\')\n            >>> x.type()\n            \'t_VEC\'\n            >>> y = x.Mat()\n            >>> y\n            Mat([1, 2, 3, 4])\n            >>> y.type()\n            \'t_MAT\'\n        ";
static PyObject *__pyx_f_7py_pari_3gen_Mat(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2376 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(gtomat(((struct __pyx_obj_7py_pari_gen *)__pyx_v_x)->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2376; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.Mat");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_Mod(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_Mod[] = "\n        Mod(x, y): creates the object x modulo y.\n\n        INPUT:\n            x -- gen\n            y -- gen\n            \n        EXAMPLES:\n            >>> z = pari(3)\n            >>> x = z.Mod(pari(7))\n            >>> x\n            Mod(3, 7)\n            >>> x**2\n            Mod(2, 7)\n            >>> x**100\n            Mod(4, 7)\n            >>> x.type()\n            \'t_INTMOD\'\n\n            >>> f = pari(\"x^2 + x + 1\")\n            >>> g = pari(\"x\")\n            >>> a = g.Mod(f)\n            >>> a\n            Mod(x, x^2 + x + 1)\n            >>> a*a\n            Mod(-x - 1, x^2 + x + 1)\n            >>> a.type()\n            \'t_POLMOD\'\n        ";
static PyObject *__pyx_f_7py_pari_3gen_Mod(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  struct __pyx_obj_7py_pari_gen *__pyx_v_y = 0;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {"y",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_y)) return 0;
  Py_INCREF(__pyx_v_x);
  Py_INCREF(__pyx_v_y);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_y), __pyx_ptype_7py_pari_gen, 1, "y")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2378; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2408 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(gmodulcp(((struct __pyx_obj_7py_pari_gen *)__pyx_v_x)->g,__pyx_v_y->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2408; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.Mod");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  Py_DECREF(__pyx_v_y);
  return __pyx_r;
}

static PyObject *__pyx_n_TypeError;

static PyObject *__pyx_k52p;

static char (__pyx_k52[]) = "Unable to convert PARI object %s to a polynomial.";

static PyObject *__pyx_f_7py_pari_3gen_Pol(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_Pol[] = "\n        Pol(x): convert x (usually a vector or a power series) into a\n        polynomial, starting with the leading coefficient\n\n        INPUT:\n            x -- gen\n        OUTPUT:\n            gen -- a polynomial\n        EXAMPLES:\n            >>> v = pari(\"[1,2,3,4]\")\n            >>> f = v.Pol()\n            >>> f\n            x^3 + 2*x^2 + 3*x + 4\n            >>> f*f\n            x^6 + 4*x^5 + 10*x^4 + 20*x^3 + 25*x^2 + 24*x + 16\n            \n            >>> v = pari(\"[1,2;3,4]\")\n            >>> v.Pol()\n            [1, 3]~*x + [2, 4]~\n        ";
static PyObject *__pyx_f_7py_pari_3gen_Pol(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  long __pyx_v_t;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2433 */
  __pyx_v_t = typ(((struct __pyx_obj_7py_pari_gen *)__pyx_v_x)->g);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2434 */
  __pyx_1 = (__pyx_v_t != t_POL);
  if (__pyx_1) {
    __pyx_1 = (__pyx_v_t != t_SER);
    if (__pyx_1) {
      __pyx_1 = (__pyx_v_t != t_POL);
      if (__pyx_1) {
        __pyx_1 = (__pyx_v_t != t_RFRAC);
        if (__pyx_1) {
          __pyx_1 = (__pyx_v_t != t_QFR);
          if (__pyx_1) {
            __pyx_1 = (__pyx_v_t != t_QFI);
            if (__pyx_1) {
              __pyx_1 = (__pyx_v_t != t_VEC);
              if (__pyx_1) {
                __pyx_1 = (__pyx_v_t != t_COL);
                if (__pyx_1) {
                  __pyx_1 = (__pyx_v_t != t_MAT);
                }
              }
            }
          }
        }
      }
    }
  }
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2436 */
    __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_TypeError); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2436; goto __pyx_L1;}
    __pyx_3 = PyNumber_Remainder(__pyx_k52p, __pyx_v_x); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2436; goto __pyx_L1;}
    __Pyx_Raise(__pyx_2, __pyx_3, 0);
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2436; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2437 */
  __pyx_2 = ((PyObject *)__pyx_f_7py_pari_new_gen(gtopoly(((struct __pyx_obj_7py_pari_gen *)__pyx_v_x)->g,0))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2437; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.Pol");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_k53p;

static char (__pyx_k53[]) = "Unable to convert PARI object %s to a polynomial.";

static PyObject *__pyx_f_7py_pari_3gen_Polrev(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_Polrev[] = "\n        Polrev(x): convert x (usually a vector or a power series) into a\n        polynomial, starting with the constant\n\n        INPUT:\n            x -- gen\n        OUTPUT:\n            gen -- a polynomial\n        EXAMPLES:\n            >>> v = pari(\"[1,2,3,4]\")\n            >>> f = v.Polrev()\n            >>> f\n            4*x^3 + 3*x^2 + 2*x + 1\n            >>> f*f\n            16*x^6 + 24*x^5 + 25*x^4 + 20*x^3 + 10*x^2 + 4*x + 1\n            \n        Note that Polrev does *not* reverse the coefficients of a polynomial!\n            >>> f.Polrev()\n            4*x^3 + 3*x^2 + 2*x + 1\n            >>> v = pari(\"[1,2;3,4]\")\n            >>> v.Polrev()\n            [2, 4]~*x + [1, 3]~\n        ";
static PyObject *__pyx_f_7py_pari_3gen_Polrev(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  long __pyx_v_t;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2465 */
  __pyx_v_t = typ(((struct __pyx_obj_7py_pari_gen *)__pyx_v_x)->g);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2466 */
  __pyx_1 = (__pyx_v_t != t_POL);
  if (__pyx_1) {
    __pyx_1 = (__pyx_v_t != t_SER);
    if (__pyx_1) {
      __pyx_1 = (__pyx_v_t != t_POL);
      if (__pyx_1) {
        __pyx_1 = (__pyx_v_t != t_RFRAC);
        if (__pyx_1) {
          __pyx_1 = (__pyx_v_t != t_QFR);
          if (__pyx_1) {
            __pyx_1 = (__pyx_v_t != t_QFI);
            if (__pyx_1) {
              __pyx_1 = (__pyx_v_t != t_VEC);
              if (__pyx_1) {
                __pyx_1 = (__pyx_v_t != t_COL);
                if (__pyx_1) {
                  __pyx_1 = (__pyx_v_t != t_MAT);
                }
              }
            }
          }
        }
      }
    }
  }
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2468 */
    __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_TypeError); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2468; goto __pyx_L1;}
    __pyx_3 = PyNumber_Remainder(__pyx_k53p, __pyx_v_x); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2468; goto __pyx_L1;}
    __Pyx_Raise(__pyx_2, __pyx_3, 0);
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2468; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2469 */
  __pyx_2 = ((PyObject *)__pyx_f_7py_pari_new_gen(gtopolyrev(((struct __pyx_obj_7py_pari_gen *)__pyx_v_x)->g,0))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2469; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.Polrev");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_Qfb(PyObject *__pyx_v_a, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_Qfb[] = "\n        Qfb(a,b,c,{D=0.}): binary quadratic form a*x^2+b*x*y+c*y^2.    D is optional\n                           (0.0 by default) and initializes Shanks\'s distance if b^2-4*a*c>0\n\n        INPUT:\n            a -- gen\n            b -- gen\n            c -- gen\n            D -- gen\n            prec -- long (default to py_pari.PREC)\n        OUTPUT:\n            gen -- binary quadratic form\n        EXAMPLES:\n            >>> a = pari(3)\n            >>> a.Qfb(pari(7), pari(2))\n            Qfb(3, 7, 2, 0.E-288)\n            \n        ";
static PyObject *__pyx_f_7py_pari_3gen_Qfb(PyObject *__pyx_v_a, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  struct __pyx_obj_7py_pari_gen *__pyx_v_b = 0;
  struct __pyx_obj_7py_pari_gen *__pyx_v_c = 0;
  struct __pyx_obj_7py_pari_gen *__pyx_v_D = 0;
  long __pyx_v_prec;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {"b","c","D","prec",0};
  __pyx_v_D = __pyx_k6;
  __pyx_v_prec = __pyx_k7;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "OO|Ol", __pyx_argnames, &__pyx_v_b, &__pyx_v_c, &__pyx_v_D, &__pyx_v_prec)) return 0;
  Py_INCREF(__pyx_v_a);
  Py_INCREF(__pyx_v_b);
  Py_INCREF(__pyx_v_c);
  Py_INCREF(__pyx_v_D);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_b), __pyx_ptype_7py_pari_gen, 1, "b")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2472; goto __pyx_L1;}
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_c), __pyx_ptype_7py_pari_gen, 1, "c")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2472; goto __pyx_L1;}
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_D), __pyx_ptype_7py_pari_gen, 1, "D")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2472; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2491 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(Qfb0(((struct __pyx_obj_7py_pari_gen *)__pyx_v_a)->g,__pyx_v_b->g,__pyx_v_c->g,__pyx_v_D->g,__pyx_v_prec))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2491; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.Qfb");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_a);
  Py_DECREF(__pyx_v_b);
  Py_DECREF(__pyx_v_c);
  Py_DECREF(__pyx_v_D);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_Ser(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_Ser[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_Ser(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2497 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2497; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2497; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.Ser");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_Set(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_Set[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_Set(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2502 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2502; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2502; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.Set");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_Str(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_Str[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_Str(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2507 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2507; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2507; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.Str");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_Strchr(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_Strchr[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_Strchr(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2512 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2512; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2512; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.Strchr");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_Strexpand(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_Strexpand[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_Strexpand(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2517 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2517; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2517; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.Strexpand");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_Strtex(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_Strtex[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_Strtex(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2522 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2522; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2522; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.Strtex");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_Vec(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_Vec[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_Vec(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2527 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(gtovec(((struct __pyx_obj_7py_pari_gen *)__pyx_v_x)->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2527; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.Vec");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_k54p;

static char (__pyx_k54[]) = "x must have PARI type one of t_VECSMALL, t_INT or t_STR";

static PyObject *__pyx_f_7py_pari_3gen_Vecsmall(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_Vecsmall[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_Vecsmall(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  long __pyx_v_t;
  PyObject *__pyx_r;
  int __pyx_1;
  int __pyx_2;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2533 */
  __pyx_v_t = typ(((struct __pyx_obj_7py_pari_gen *)__pyx_v_x)->g);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2534 */
  __pyx_1 = (__pyx_v_t == t_VECSMALL);
  if (!__pyx_1) {
    __pyx_1 = (__pyx_v_t == t_INT);
    if (!__pyx_1) {
      __pyx_1 = (__pyx_v_t == t_STR);
    }
  }
  __pyx_2 = (!__pyx_1);
  if (__pyx_2) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2535 */
    __pyx_3 = __Pyx_GetName(__pyx_b, __pyx_n_TypeError); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2535; goto __pyx_L1;}
    __Pyx_Raise(__pyx_3, __pyx_k54p, 0);
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2535; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2536 */
  __pyx_3 = ((PyObject *)__pyx_f_7py_pari_new_gen(gtovecsmall(((struct __pyx_obj_7py_pari_gen *)__pyx_v_x)->g))); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2536; goto __pyx_L1;}
  __pyx_r = __pyx_3;
  __pyx_3 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.Vecsmall");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_binary(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_binary[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_binary(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2541 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2541; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2541; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.binary");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_bitand(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_bitand[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_bitand(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2546 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2546; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2546; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.bitand");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_bitneg(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_bitneg[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_bitneg(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2551 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2551; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2551; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.bitneg");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_bitnegimply(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_bitnegimply[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_bitnegimply(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2556 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2556; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2556; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.bitnegimply");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_bitor(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_bitor[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_bitor(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2561 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2561; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2561; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.bitor");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_bittest(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_bittest[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_bittest(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2566 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2566; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2566; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.bittest");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_bitxor(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_bitxor[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_bitxor(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2571 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2571; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2571; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.bitxor");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_ceil(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_ceil[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_ceil(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2576 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2576; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2576; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.ceil");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_centerlift(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_centerlift[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_centerlift(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2581 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2581; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2581; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.centerlift");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_changevar(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_changevar[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_changevar(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2586 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2586; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2586; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.changevar");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_component(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_component[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_component(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2591 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2591; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2591; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.component");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_conj(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_conj[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_conj(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2596 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2596; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2596; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.conj");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_conjvec(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_conjvec[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_conjvec(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2601 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2601; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2601; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.conjvec");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_denominator(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_denominator[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_denominator(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2606 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2606; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2606; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.denominator");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_floor(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_floor[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_floor(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2611 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(gfloor(((struct __pyx_obj_7py_pari_gen *)__pyx_v_x)->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2611; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.floor");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_frac(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_frac[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_frac(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2616 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2616; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2616; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.frac");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_imag(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_imag[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_imag(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2621 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2621; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2621; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.imag");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_length(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_length[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_length(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2626 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2626; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2626; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.length");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_lift(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_lift[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_lift(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2631 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2631; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2631; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.lift");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_norm(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_norm[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_norm(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2636 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2636; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2636; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.norm");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_norml2(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_norml2[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_norml2(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2641 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2641; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2641; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.norml2");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_numerator(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_numerator[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_numerator(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2646 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2646; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2646; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.numerator");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_numtoperm(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_numtoperm[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_numtoperm(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2651 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2651; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2651; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.numtoperm");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_padicprec(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_padicprec[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_padicprec(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2656 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2656; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2656; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.padicprec");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_permtonum(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_permtonum[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_permtonum(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2661 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2661; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2661; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.permtonum");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_precision(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_precision[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_precision(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2666 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2666; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2666; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.precision");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_random(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_random[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_random(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2671 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2671; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2671; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.random");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_real(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_real[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_real(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2676 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2676; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2676; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.real");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_round(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_round[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_round(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2681 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2681; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2681; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.round");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_simplify(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_simplify[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_simplify(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2686 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2686; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2686; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.simplify");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_sizebyte(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_sizebyte[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_sizebyte(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2691 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2691; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2691; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.sizebyte");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_sizedigit(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_sizedigit[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_sizedigit(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2696 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2696; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2696; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.sizedigit");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_truncate(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_truncate[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_truncate(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2701 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2701; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2701; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.truncate");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_valuation(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_valuation[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_valuation(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2706 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2706; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2706; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.valuation");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_variable(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_variable[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_variable(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2711 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_NotImplementedError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2711; goto __pyx_L1;}
  __Pyx_Raise(__pyx_1, 0, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2711; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.variable");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_elladd(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_elladd[] = "\n        e.elladd(z1, z2)\n\n        Sum of the points z1 and z2 on the elliptic curve e.\n\n        INPUT:\n            e -- elliptic curve E\n            z1 -- point on E\n            z2 -- point on E\n            \n        OUTPUT:\n            point on E\n\n        EXAMPLES:\n            >>> e = pari(\"ellinit([0, 1, 1, -2, 0])\")\n            >>> z1 = pari(\"[1,0,1]\")\n            >>> z2 = pari(\"[-1,1,1]\")\n            >>> e.elladd(z1, z2)\n            [-3/4, -15/8]\n        ";
static PyObject *__pyx_f_7py_pari_3gen_elladd(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  struct __pyx_obj_7py_pari_gen *__pyx_v_z1 = 0;
  struct __pyx_obj_7py_pari_gen *__pyx_v_z2 = 0;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {"z1","z2",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "OO", __pyx_argnames, &__pyx_v_z1, &__pyx_v_z2)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_z1);
  Py_INCREF(__pyx_v_z2);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_z1), __pyx_ptype_7py_pari_gen, 1, "z1")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2727; goto __pyx_L1;}
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_z2), __pyx_ptype_7py_pari_gen, 1, "z2")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2727; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2748 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(addell(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g,__pyx_v_z1->g,__pyx_v_z2->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2748; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.elladd");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_z1);
  Py_DECREF(__pyx_v_z2);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_ellak(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_ellak[] = "\n        e.ellak(n)\n\n        Returns the coefficient a_n of the L-function of the elliptic\n        curve e, i.e. the coefficient of a newform of weight 2 newform.\n        The curve e must be a medium or long vector of the type given\n        by ellinit. For this function to work for every n and not\n        just those prime to the conductor, e must be a minimal Weierstrass\n        equation. If this is not the case, use the function\n        ellminimalmodel first before using ellak.\n\n        INPUT:\n            n -- integer ..\n        ";
static PyObject *__pyx_f_7py_pari_3gen_ellak(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  struct __pyx_obj_7py_pari_gen *__pyx_v_n = 0;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {"n",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_n)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_n);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_n), __pyx_ptype_7py_pari_gen, 1, "n")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2750; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2765 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(akell(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g,__pyx_v_n->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2765; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.ellak");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_n);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_ellan(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_ellan(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  long __pyx_v_n;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {"n",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "l", __pyx_argnames, &__pyx_v_n)) return 0;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2768 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(anell(forcecopy(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g),__pyx_v_n))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2768; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.ellan");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_n_isprime;
static PyObject *__pyx_n_ArithmeticError;

static PyObject *__pyx_k55p;
static PyObject *__pyx_k56p;

static char (__pyx_k55[]) = "p must be of type t_INT";
static char (__pyx_k56[]) = "p (=%s) must be a prime";

static PyObject *__pyx_f_7py_pari_3gen_ellap(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_ellap(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  struct __pyx_obj_7py_pari_gen *__pyx_v_p = 0;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {"p",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_p)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_p);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_p), __pyx_ptype_7py_pari_gen, 1, "p")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2770; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2771 */
  __pyx_1 = (typ(__pyx_v_p->g) != t_INT);
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2772 */
    __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_TypeError); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2772; goto __pyx_L1;}
    __Pyx_Raise(__pyx_2, __pyx_k55p, 0);
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2772; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2773 */
  __pyx_2 = PyObject_GetAttr(((PyObject *)__pyx_v_p), __pyx_n_isprime); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2773; goto __pyx_L1;}
  __pyx_3 = PyTuple_New(0); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2773; goto __pyx_L1;}
  __pyx_4 = PyObject_CallObject(__pyx_2, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2773; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  if (PyObject_Cmp(__pyx_4, ((PyObject *)__pyx_v_7py_pari_ZERO), &__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2773; goto __pyx_L1;}
  __pyx_1 = __pyx_1 == 0;
  Py_DECREF(__pyx_4); __pyx_4 = 0;
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2774 */
    __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_ArithmeticError); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2774; goto __pyx_L1;}
    __pyx_3 = PyNumber_Remainder(__pyx_k56p, ((PyObject *)__pyx_v_p)); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2774; goto __pyx_L1;}
    __Pyx_Raise(__pyx_2, __pyx_3, 0);
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2774; goto __pyx_L1;}
    goto __pyx_L3;
  }
  __pyx_L3:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2775 */
  __pyx_4 = ((PyObject *)__pyx_f_7py_pari_new_gen(apell(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g,__pyx_v_p->g))); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2775; goto __pyx_L1;}
  __pyx_r = __pyx_4;
  __pyx_4 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari.gen.ellap");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_p);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_ellbil(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_ellbil(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  struct __pyx_obj_7py_pari_gen *__pyx_v_z1 = 0;
  struct __pyx_obj_7py_pari_gen *__pyx_v_z2 = 0;
  long __pyx_v_prec;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {"z1","z2","prec",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "OOl", __pyx_argnames, &__pyx_v_z1, &__pyx_v_z2, &__pyx_v_prec)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_z1);
  Py_INCREF(__pyx_v_z2);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_z1), __pyx_ptype_7py_pari_gen, 1, "z1")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2780; goto __pyx_L1;}
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_z2), __pyx_ptype_7py_pari_gen, 1, "z2")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2780; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2781 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(bilhell(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g,__pyx_v_z1->g,__pyx_v_z2->g,__pyx_v_prec))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2781; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.ellbil");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_z1);
  Py_DECREF(__pyx_v_z2);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_ellchangecurve(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_ellchangecurve[] = "\n        ";
static PyObject *__pyx_f_7py_pari_3gen_ellchangecurve(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  struct __pyx_obj_7py_pari_gen *__pyx_v_ch = 0;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {"ch",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_ch)) return 0;
  Py_INCREF(__pyx_v_e);
  Py_INCREF(__pyx_v_ch);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_ch), __pyx_ptype_7py_pari_gen, 1, "ch")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2783; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2786 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(coordch(((struct __pyx_obj_7py_pari_gen *)__pyx_v_e)->g,__pyx_v_ch->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2786; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.ellchangecurve");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_e);
  Py_DECREF(__pyx_v_ch);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_ellchangepoint(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_ellchangepoint[] = "\n        ellchangepoint(x,y)\n\n        change data on point or vector of points x on an elliptic curve according\n        to y=[u,r,s,t]\n        ";
static PyObject *__pyx_f_7py_pari_3gen_ellchangepoint(PyObject *__pyx_v_x, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  struct __pyx_obj_7py_pari_gen *__pyx_v_y = 0;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {"y",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_y)) return 0;
  Py_INCREF(__pyx_v_x);
  Py_INCREF(__pyx_v_y);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_y), __pyx_ptype_7py_pari_gen, 1, "y")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2788; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2795 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(pointch(((struct __pyx_obj_7py_pari_gen *)__pyx_v_x)->g,__pyx_v_y->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2795; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.ellchangepoint");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  Py_DECREF(__pyx_v_y);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_elleisnum(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_elleisnum(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  long __pyx_v_k;
  PyObject *__pyx_v_flag = 0;
  PyObject *__pyx_v_prec = 0;
  PyObject *__pyx_r;
  long __pyx_1;
  long __pyx_2;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {"k","flag","prec",0};
  __pyx_v_flag = __pyx_k8;
  __pyx_v_prec = __pyx_k9;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "l|OO", __pyx_argnames, &__pyx_v_k, &__pyx_v_flag, &__pyx_v_prec)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_flag);
  Py_INCREF(__pyx_v_prec);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2798 */
  __pyx_1 = PyInt_AsLong(__pyx_v_flag); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2798; goto __pyx_L1;}
  __pyx_2 = PyInt_AsLong(__pyx_v_prec); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2798; goto __pyx_L1;}
  __pyx_3 = ((PyObject *)__pyx_f_7py_pari_new_gen(elleisnum(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g,__pyx_v_k,__pyx_1,__pyx_2))); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2798; goto __pyx_L1;}
  __pyx_r = __pyx_3;
  __pyx_3 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.elleisnum");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_flag);
  Py_DECREF(__pyx_v_prec);
  return __pyx_r;
}

static PyObject *__pyx_n_g;

static PyObject *__pyx_f_7py_pari_3gen_elleta(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_elleta(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_prec = 0;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  long __pyx_2;
  static char *__pyx_argnames[] = {"prec",0};
  __pyx_v_prec = __pyx_k10;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|O", __pyx_argnames, &__pyx_v_prec)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_prec);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2801 */
  __pyx_1 = PyObject_GetAttr(__pyx_v_prec, __pyx_n_g); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2801; goto __pyx_L1;}
  __pyx_2 = PyInt_AsLong(__pyx_1); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2801; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(elleta(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g,__pyx_2))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2801; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.elleta");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_prec);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_ellglobalred(PyObject *__pyx_v_e1, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_ellglobalred(PyObject *__pyx_v_e1, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_e1);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2804 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(globalreduction(((struct __pyx_obj_7py_pari_gen *)__pyx_v_e1)->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2804; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.ellglobalred");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_e1);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_ellheight(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_ellheight(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  struct __pyx_obj_7py_pari_gen *__pyx_v_a = 0;
  PyObject *__pyx_v_flag = 0;
  PyObject *__pyx_v_prec = 0;
  PyObject *__pyx_r;
  long __pyx_1;
  long __pyx_2;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {"a","flag","prec",0};
  __pyx_v_flag = __pyx_k11;
  __pyx_v_prec = __pyx_k12;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O|OO", __pyx_argnames, &__pyx_v_a, &__pyx_v_flag, &__pyx_v_prec)) return 0;
  Py_INCREF(__pyx_v_e);
  Py_INCREF(__pyx_v_a);
  Py_INCREF(__pyx_v_flag);
  Py_INCREF(__pyx_v_prec);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_a), __pyx_ptype_7py_pari_gen, 1, "a")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2806; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2807 */
  __pyx_1 = PyInt_AsLong(__pyx_v_flag); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2807; goto __pyx_L1;}
  __pyx_2 = PyInt_AsLong(__pyx_v_prec); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2807; goto __pyx_L1;}
  __pyx_3 = ((PyObject *)__pyx_f_7py_pari_new_gen(ellheight0(((struct __pyx_obj_7py_pari_gen *)__pyx_v_e)->g,__pyx_v_a->g,__pyx_1,__pyx_2))); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2807; goto __pyx_L1;}
  __pyx_r = __pyx_3;
  __pyx_3 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.ellheight");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_e);
  Py_DECREF(__pyx_v_a);
  Py_DECREF(__pyx_v_flag);
  Py_DECREF(__pyx_v_prec);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_ellheightmatrix(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_ellheightmatrix[] = "\n        ellheightmatrix(e,x)\n\n        Returns the height matrix for vector of points x on elliptic curve e using\n        theta functions.\n        ";
static PyObject *__pyx_f_7py_pari_3gen_ellheightmatrix(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  struct __pyx_obj_7py_pari_gen *__pyx_v_x = 0;
  long __pyx_v_prec;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {"x","prec",0};
  __pyx_v_prec = __pyx_k13;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O|l", __pyx_argnames, &__pyx_v_x, &__pyx_v_prec)) return 0;
  Py_INCREF(__pyx_v_e);
  Py_INCREF(__pyx_v_x);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_x), __pyx_ptype_7py_pari_gen, 1, "x")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2809; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2816 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(mathell(((struct __pyx_obj_7py_pari_gen *)__pyx_v_e)->g,__pyx_v_x->g,__pyx_v_prec))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2816; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.ellheightmatrix");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_e);
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_ellinit(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_3gen_ellinit[] = "\n        ellinit(x,{flag=0}): x being the vector [a1,a2,a3,a4,a6], gives\n        the vector: [a1,a2,a3,a4,a6,\n                    b2,b4,b6,b8,\n                    c4,c6,\n                    delta,j,\n                    [e1,e2,e3],\n                    w1,w2,eta1,eta2,area].\n        If the curve is defined over a p-adic field, the last six components\n        are replaced by root,u^2,u,q,w,0. If optional flag is 1, omit them\n        altogether.\n        ";
static PyObject *__pyx_f_7py_pari_3gen_ellinit(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_flag = 0;
  PyObject *__pyx_v_prec = 0;
  PyObject *__pyx_r;
  long __pyx_1;
  long __pyx_2;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {"flag","prec",0};
  __pyx_v_flag = __pyx_k14;
  __pyx_v_prec = __pyx_k15;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|OO", __pyx_argnames, &__pyx_v_flag, &__pyx_v_prec)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_flag);
  Py_INCREF(__pyx_v_prec);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2836 */
  __pyx_1 = PyInt_AsLong(__pyx_v_flag); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2836; goto __pyx_L1;}
  __pyx_2 = PyInt_AsLong(__pyx_v_prec); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2836; goto __pyx_L1;}
  __pyx_3 = ((PyObject *)__pyx_f_7py_pari_new_gen(ellinit0(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g,__pyx_1,__pyx_2))); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2836; goto __pyx_L1;}
  __pyx_r = __pyx_3;
  __pyx_3 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.ellinit");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_flag);
  Py_DECREF(__pyx_v_prec);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_ellisoncurve(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_ellisoncurve(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  struct __pyx_obj_7py_pari_gen *__pyx_v_x = 0;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {"x",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_x)) return 0;
  Py_INCREF(__pyx_v_e);
  Py_INCREF(__pyx_v_x);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_x), __pyx_ptype_7py_pari_gen, 1, "x")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2838; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2839 */
  __pyx_1 = PyInt_FromLong(oncurve(((struct __pyx_obj_7py_pari_gen *)__pyx_v_e)->g,__pyx_v_x->g)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2839; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.ellisoncurve");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_e);
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_ellj(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_ellj(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  long __pyx_v_prec;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {"prec",0};
  __pyx_v_prec = __pyx_k16;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|l", __pyx_argnames, &__pyx_v_prec)) return 0;
  Py_INCREF(__pyx_v_e);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2842 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(jell(((struct __pyx_obj_7py_pari_gen *)__pyx_v_e)->g,__pyx_v_prec))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2842; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.ellj");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_e);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_elllocalred(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_elllocalred(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  struct __pyx_obj_7py_pari_gen *__pyx_v_p = 0;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {"p",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_p)) return 0;
  Py_INCREF(__pyx_v_e);
  Py_INCREF(__pyx_v_p);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_p), __pyx_ptype_7py_pari_gen, 1, "p")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2844; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2845 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(localreduction(((struct __pyx_obj_7py_pari_gen *)__pyx_v_e)->g,__pyx_v_p->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2845; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.elllocalred");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_e);
  Py_DECREF(__pyx_v_p);
  return __pyx_r;
}

static PyObject *__pyx_k57p;

static char (__pyx_k57[]) = "prec must be >= 3.";

static PyObject *__pyx_f_7py_pari_3gen_elllseries(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_elllseries(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  struct __pyx_obj_7py_pari_gen *__pyx_v_s = 0;
  struct __pyx_obj_7py_pari_gen *__pyx_v_A = 0;
  long __pyx_v_prec;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  static char *__pyx_argnames[] = {"s","A","prec",0};
  __pyx_v_A = __pyx_k17;
  __pyx_v_prec = __pyx_k18;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O|Ol", __pyx_argnames, &__pyx_v_s, &__pyx_v_A, &__pyx_v_prec)) return 0;
  Py_INCREF(__pyx_v_e);
  Py_INCREF(__pyx_v_s);
  Py_INCREF(__pyx_v_A);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_s), __pyx_ptype_7py_pari_gen, 1, "s")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2847; goto __pyx_L1;}
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_A), __pyx_ptype_7py_pari_gen, 1, "A")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2847; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2848 */
  __pyx_1 = (__pyx_v_prec <= 2);
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2849 */
    __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_RuntimeError); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2849; goto __pyx_L1;}
    __Pyx_Raise(__pyx_2, __pyx_k57p, 0);
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2849; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2850 */
  __pyx_2 = ((PyObject *)__pyx_f_7py_pari_new_gen(lseriesell(((struct __pyx_obj_7py_pari_gen *)__pyx_v_e)->g,__pyx_v_s->g,__pyx_v_A->g,__pyx_v_prec))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2850; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("py_pari.gen.elllseries");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_e);
  Py_DECREF(__pyx_v_s);
  Py_DECREF(__pyx_v_A);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_ellminimalmodel(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_ellminimalmodel(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  GEN __pyx_v_x;
  GEN __pyx_v_y;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_e);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2854 */
  __pyx_v_x = ellminimalmodel(((struct __pyx_obj_7py_pari_gen *)__pyx_v_e)->g,(&__pyx_v_y));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2855 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(__pyx_v_x)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2855; goto __pyx_L1;}
  __pyx_2 = ((PyObject *)__pyx_f_7py_pari_new_gen(__pyx_v_y)); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2855; goto __pyx_L1;}
  __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2855; goto __pyx_L1;}
  PyTuple_SET_ITEM(__pyx_3, 0, __pyx_1);
  PyTuple_SET_ITEM(__pyx_3, 1, __pyx_2);
  __pyx_1 = 0;
  __pyx_2 = 0;
  __pyx_r = __pyx_3;
  __pyx_3 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.ellminimalmodel");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_e);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_ellorder(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_ellorder(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  struct __pyx_obj_7py_pari_gen *__pyx_v_x = 0;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {"x",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_x)) return 0;
  Py_INCREF(__pyx_v_e);
  Py_INCREF(__pyx_v_x);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_x), __pyx_ptype_7py_pari_gen, 1, "x")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2857; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2858 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(orderell(((struct __pyx_obj_7py_pari_gen *)__pyx_v_e)->g,__pyx_v_x->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2858; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.ellorder");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_e);
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_ellordinate(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_ellordinate(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  struct __pyx_obj_7py_pari_gen *__pyx_v_x = 0;
  long __pyx_v_prec;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {"x","prec",0};
  __pyx_v_prec = __pyx_k19;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O|l", __pyx_argnames, &__pyx_v_x, &__pyx_v_prec)) return 0;
  Py_INCREF(__pyx_v_e);
  Py_INCREF(__pyx_v_x);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_x), __pyx_ptype_7py_pari_gen, 1, "x")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2860; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2861 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(ordell(((struct __pyx_obj_7py_pari_gen *)__pyx_v_e)->g,__pyx_v_x->g,__pyx_v_prec))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2861; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.ellordinate");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_e);
  Py_DECREF(__pyx_v_x);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_ellpointtoz(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_ellpointtoz(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  struct __pyx_obj_7py_pari_gen *__pyx_v_z = 0;
  long __pyx_v_prec;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {"z","prec",0};
  __pyx_v_prec = __pyx_k20;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O|l", __pyx_argnames, &__pyx_v_z, &__pyx_v_prec)) return 0;
  Py_INCREF(__pyx_v_e);
  Py_INCREF(__pyx_v_z);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_z), __pyx_ptype_7py_pari_gen, 1, "z")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2863; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2864 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(zell(((struct __pyx_obj_7py_pari_gen *)__pyx_v_e)->g,__pyx_v_z->g,__pyx_v_prec))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2864; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.ellpointtoz");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_e);
  Py_DECREF(__pyx_v_z);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_ellpow(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_ellpow(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  struct __pyx_obj_7py_pari_gen *__pyx_v_z = 0;
  struct __pyx_obj_7py_pari_gen *__pyx_v_n = 0;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {"z","n",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "OO", __pyx_argnames, &__pyx_v_z, &__pyx_v_n)) return 0;
  Py_INCREF(__pyx_v_e);
  Py_INCREF(__pyx_v_z);
  Py_INCREF(__pyx_v_n);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_z), __pyx_ptype_7py_pari_gen, 1, "z")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2866; goto __pyx_L1;}
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_n), __pyx_ptype_7py_pari_gen, 1, "n")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2866; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2867 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(powell(((struct __pyx_obj_7py_pari_gen *)__pyx_v_e)->g,__pyx_v_z->g,__pyx_v_n->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2867; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.ellpow");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_e);
  Py_DECREF(__pyx_v_z);
  Py_DECREF(__pyx_v_n);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_ellrootno(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_ellrootno(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  struct __pyx_obj_7py_pari_gen *__pyx_v_p = 0;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {"p",0};
  __pyx_v_p = __pyx_k21;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|O", __pyx_argnames, &__pyx_v_p)) return 0;
  Py_INCREF(__pyx_v_e);
  Py_INCREF(__pyx_v_p);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_p), __pyx_ptype_7py_pari_gen, 1, "p")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2869; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2870 */
  __pyx_1 = PyInt_FromLong(ellrootno(((struct __pyx_obj_7py_pari_gen *)__pyx_v_e)->g,__pyx_v_p->g)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2870; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.ellrootno");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_e);
  Py_DECREF(__pyx_v_p);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_ellsigma(PyObject *__pyx_v_om, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_ellsigma(PyObject *__pyx_v_om, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  struct __pyx_obj_7py_pari_gen *__pyx_v_z = 0;
  PyObject *__pyx_v_flag = 0;
  PyObject *__pyx_v_prec = 0;
  PyObject *__pyx_r;
  long __pyx_1;
  long __pyx_2;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {"z","flag","prec",0};
  __pyx_v_flag = __pyx_k22;
  __pyx_v_prec = __pyx_k23;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O|OO", __pyx_argnames, &__pyx_v_z, &__pyx_v_flag, &__pyx_v_prec)) return 0;
  Py_INCREF(__pyx_v_om);
  Py_INCREF(__pyx_v_z);
  Py_INCREF(__pyx_v_flag);
  Py_INCREF(__pyx_v_prec);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_z), __pyx_ptype_7py_pari_gen, 1, "z")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2872; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2873 */
  __pyx_1 = PyInt_AsLong(__pyx_v_flag); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2873; goto __pyx_L1;}
  __pyx_2 = PyInt_AsLong(__pyx_v_prec); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2873; goto __pyx_L1;}
  __pyx_3 = ((PyObject *)__pyx_f_7py_pari_new_gen(ellsigma(((struct __pyx_obj_7py_pari_gen *)__pyx_v_om)->g,__pyx_v_z->g,__pyx_1,__pyx_2))); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2873; goto __pyx_L1;}
  __pyx_r = __pyx_3;
  __pyx_3 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.ellsigma");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_om);
  Py_DECREF(__pyx_v_z);
  Py_DECREF(__pyx_v_flag);
  Py_DECREF(__pyx_v_prec);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_ellsub(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_ellsub(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  struct __pyx_obj_7py_pari_gen *__pyx_v_z1 = 0;
  struct __pyx_obj_7py_pari_gen *__pyx_v_z2 = 0;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {"z1","z2",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "OO", __pyx_argnames, &__pyx_v_z1, &__pyx_v_z2)) return 0;
  Py_INCREF(__pyx_v_e);
  Py_INCREF(__pyx_v_z1);
  Py_INCREF(__pyx_v_z2);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_z1), __pyx_ptype_7py_pari_gen, 1, "z1")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2875; goto __pyx_L1;}
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_z2), __pyx_ptype_7py_pari_gen, 1, "z2")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2875; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2876 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(subell(((struct __pyx_obj_7py_pari_gen *)__pyx_v_e)->g,__pyx_v_z1->g,__pyx_v_z2->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2876; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.ellsub");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_e);
  Py_DECREF(__pyx_v_z1);
  Py_DECREF(__pyx_v_z2);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_elltaniyama(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_elltaniyama(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_e);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2879 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(taniyama(((struct __pyx_obj_7py_pari_gen *)__pyx_v_e)->g))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2879; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.elltaniyama");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_e);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_elltors(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_elltors(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_flag = 0;
  PyObject *__pyx_r;
  long __pyx_1;
  PyObject *__pyx_2 = 0;
  static char *__pyx_argnames[] = {"flag",0};
  __pyx_v_flag = __pyx_k24;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|O", __pyx_argnames, &__pyx_v_flag)) return 0;
  Py_INCREF(__pyx_v_e);
  Py_INCREF(__pyx_v_flag);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2882 */
  __pyx_1 = PyInt_AsLong(__pyx_v_flag); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2882; goto __pyx_L1;}
  __pyx_2 = ((PyObject *)__pyx_f_7py_pari_new_gen(elltors0(((struct __pyx_obj_7py_pari_gen *)__pyx_v_e)->g,__pyx_1))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2882; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("py_pari.gen.elltors");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_e);
  Py_DECREF(__pyx_v_flag);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_ellwp(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_ellwp(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  struct __pyx_obj_7py_pari_gen *__pyx_v_z = 0;
  long __pyx_v_flag;
  long __pyx_v_prec;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {"z","flag","prec",0};
  __pyx_v_flag = __pyx_k25;
  __pyx_v_prec = __pyx_k26;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O|ll", __pyx_argnames, &__pyx_v_z, &__pyx_v_flag, &__pyx_v_prec)) return 0;
  Py_INCREF(__pyx_v_e);
  Py_INCREF(__pyx_v_z);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_z), __pyx_ptype_7py_pari_gen, 1, "z")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2884; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2885 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(ellwp0(((struct __pyx_obj_7py_pari_gen *)__pyx_v_e)->g,__pyx_v_z->g,__pyx_v_flag,__pyx_v_prec,__pyx_v_prec))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2885; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.ellwp");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_e);
  Py_DECREF(__pyx_v_z);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_ellzeta(PyObject *__pyx_v_om, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_ellzeta(PyObject *__pyx_v_om, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  struct __pyx_obj_7py_pari_gen *__pyx_v_z = 0;
  long __pyx_v_prec;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {"z","prec",0};
  __pyx_v_prec = __pyx_k27;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O|l", __pyx_argnames, &__pyx_v_z, &__pyx_v_prec)) return 0;
  Py_INCREF(__pyx_v_om);
  Py_INCREF(__pyx_v_z);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_z), __pyx_ptype_7py_pari_gen, 1, "z")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2887; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2888 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(ellzeta(((struct __pyx_obj_7py_pari_gen *)__pyx_v_om)->g,__pyx_v_z->g,__pyx_v_prec))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2888; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.ellzeta");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_om);
  Py_DECREF(__pyx_v_z);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_ellztopoint(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_ellztopoint(PyObject *__pyx_v_e, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  struct __pyx_obj_7py_pari_gen *__pyx_v_z = 0;
  long __pyx_v_prec;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {"z","prec",0};
  __pyx_v_prec = __pyx_k28;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O|l", __pyx_argnames, &__pyx_v_z, &__pyx_v_prec)) return 0;
  Py_INCREF(__pyx_v_e);
  Py_INCREF(__pyx_v_z);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_z), __pyx_ptype_7py_pari_gen, 1, "z")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2890; goto __pyx_L1;}

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2891 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(pointell(((struct __pyx_obj_7py_pari_gen *)__pyx_v_e)->g,__pyx_v_z->g,__pyx_v_prec))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2891; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.gen.ellztopoint");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_e);
  Py_DECREF(__pyx_v_z);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_factor(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_factor(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_limit = 0;
  PyObject *__pyx_r;
  long __pyx_1;
  PyObject *__pyx_2 = 0;
  static char *__pyx_argnames[] = {"limit",0};
  __pyx_v_limit = __pyx_k29;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|O", __pyx_argnames, &__pyx_v_limit)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_limit);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2919 */
  __pyx_1 = PyInt_AsLong(__pyx_v_limit); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2919; goto __pyx_L1;}
  __pyx_2 = ((PyObject *)__pyx_f_7py_pari_new_gen(factor0(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g,__pyx_1))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2919; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("py_pari.gen.factor");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_limit);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_exp(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_exp(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_prec = 0;
  PyObject *__pyx_r;
  long __pyx_1;
  PyObject *__pyx_2 = 0;
  static char *__pyx_argnames[] = {"prec",0};
  __pyx_v_prec = __pyx_k30;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|O", __pyx_argnames, &__pyx_v_prec)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_prec);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2926 */
  __pyx_1 = PyInt_AsLong(__pyx_v_prec); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2926; goto __pyx_L1;}
  __pyx_2 = ((PyObject *)__pyx_f_7py_pari_new_gen(gexp(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g,__pyx_1))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2926; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("py_pari.gen.exp");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_prec);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_log(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_log(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_prec = 0;
  PyObject *__pyx_r;
  long __pyx_1;
  PyObject *__pyx_2 = 0;
  static char *__pyx_argnames[] = {"prec",0};
  __pyx_v_prec = __pyx_k31;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|O", __pyx_argnames, &__pyx_v_prec)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_prec);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2929 */
  __pyx_1 = PyInt_AsLong(__pyx_v_prec); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2929; goto __pyx_L1;}
  __pyx_2 = ((PyObject *)__pyx_f_7py_pari_new_gen(glog(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g,__pyx_1))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2929; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("py_pari.gen.log");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_prec);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_3gen_type(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_3gen_type(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_self);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2932 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_str); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2932; goto __pyx_L1;}
  __pyx_2 = PyString_FromString(type_name(typ(((struct __pyx_obj_7py_pari_gen *)__pyx_v_self)->g))); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2932; goto __pyx_L1;}
  __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2932; goto __pyx_L1;}
  PyTuple_SET_ITEM(__pyx_3, 0, __pyx_2);
  __pyx_2 = 0;
  __pyx_2 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2932; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.gen.type");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_save_avma(void) {
  PyObject *__pyx_r;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2952 */
  __pyx_v_7py_pari_stack_avma = avma;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  __Pyx_AddTraceback("py_pari.save_avma");
  __pyx_r = 0;
  __pyx_L0:;
  return __pyx_r;
}

static struct __pyx_obj_7py_pari_gen *__pyx_f_7py_pari_new_gen(GEN __pyx_v_x) {
  size_t __pyx_v_s;
  pari_sp __pyx_v_stack_bot;
  pari_sp __pyx_v_stack_top;
  GEN __pyx_v_h;
  struct __pyx_obj_7py_pari_gen *__pyx_v_p;
  struct __pyx_obj_7py_pari_gen *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  ((PyObject*)__pyx_v_p) = Py_None; Py_INCREF(((PyObject*)__pyx_v_p));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2962 */
  __pyx_1 = (((pari_sp )__pyx_v_x) < bot);
  if (!__pyx_1) {
    __pyx_1 = (((pari_sp )__pyx_v_x) > top);
  }
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2963 */
    __pyx_2 = PyTuple_New(0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2963; goto __pyx_L1;}
    __pyx_3 = PyObject_CallObject(((PyObject*)__pyx_ptype_7py_pari_gen), __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2963; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    if (!__Pyx_TypeTest(__pyx_3, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2963; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v_p));
    ((PyObject *)__pyx_v_p) = __pyx_3;
    __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2964 */
    __pyx_2 = ((struct __pyx_vtabstruct_7py_pari_gen *)__pyx_v_p->__pyx_vtab)->init(__pyx_v_p,__pyx_v_x,0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2964; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2965 */
    avma = __pyx_v_7py_pari_stack_avma;

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2966 */
    Py_INCREF(((PyObject *)__pyx_v_p));
    __pyx_r = (struct __pyx_obj_7py_pari_gen *)((PyObject *)__pyx_v_p);
    goto __pyx_L0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2968 */
  __pyx_v_stack_top = top;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2969 */
  __pyx_v_stack_bot = bot;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2970 */
  __pyx_v_s = ((size_t )(__pyx_v_7py_pari_stack_avma - avma));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2972 */
  bot = ((pari_sp )PyMem_Malloc(__pyx_v_s));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2973 */
  top = (bot + __pyx_v_s);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2974 */
  avma = top;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2975 */
  __pyx_v_h = forcecopy(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2976 */
  __pyx_3 = PyTuple_New(0); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2976; goto __pyx_L1;}
  __pyx_2 = PyObject_CallObject(((PyObject*)__pyx_ptype_7py_pari_gen), __pyx_3); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2976; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  if (!__Pyx_TypeTest(__pyx_2, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2976; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v_p));
  ((PyObject *)__pyx_v_p) = __pyx_2;
  __pyx_2 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2976 */
  __pyx_3 = ((struct __pyx_vtabstruct_7py_pari_gen *)__pyx_v_p->__pyx_vtab)->init(__pyx_v_p,__pyx_v_h,bot); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2976; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2979 */
  top = __pyx_v_stack_top;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2980 */
  bot = __pyx_v_stack_bot;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2981 */
  avma = __pyx_v_7py_pari_stack_avma;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2983 */
  Py_INCREF(((PyObject *)__pyx_v_p));
  __pyx_r = (struct __pyx_obj_7py_pari_gen *)((PyObject *)__pyx_v_p);
  goto __pyx_L0;

  (PyObject *)__pyx_r = Py_None; Py_INCREF((PyObject *)__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.new_gen");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_p);
  return ((struct __pyx_obj_7py_pari_gen *)__pyx_r) ;
}

static struct __pyx_obj_7py_pari_gen *__pyx_f_7py_pari_new_ref(GEN __pyx_v_x,struct __pyx_obj_7py_pari_gen *__pyx_v_g) {
  struct __pyx_obj_7py_pari_gen *__pyx_v_p;
  struct __pyx_obj_7py_pari_gen *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  Py_INCREF(__pyx_v_g);
  ((PyObject*)__pyx_v_p) = Py_None; Py_INCREF(((PyObject*)__pyx_v_p));

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2987 */
  __pyx_1 = PyTuple_New(0); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2987; goto __pyx_L1;}
  __pyx_2 = PyObject_CallObject(((PyObject*)__pyx_ptype_7py_pari_gen), __pyx_1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2987; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  if (!__Pyx_TypeTest(__pyx_2, __pyx_ptype_7py_pari_gen)) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2987; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v_p));
  ((PyObject *)__pyx_v_p) = __pyx_2;
  __pyx_2 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2987 */
  __pyx_1 = ((struct __pyx_vtabstruct_7py_pari_gen *)__pyx_v_p->__pyx_vtab)->init(__pyx_v_p,__pyx_v_x,0); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2987; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2988 */
  __pyx_2 = PyInt_FromLong((-1)); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2988; goto __pyx_L1;}
  if (PyObject_SetItem(__pyx_v_p->refers_to, __pyx_2, ((PyObject *)__pyx_v_g)) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2988; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2990 */
  Py_INCREF(((PyObject *)__pyx_v_p));
  __pyx_r = (struct __pyx_obj_7py_pari_gen *)((PyObject *)__pyx_v_p);
  goto __pyx_L0;

  (PyObject *)__pyx_r = Py_None; Py_INCREF((PyObject *)__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("py_pari.new_ref");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_p);
  Py_DECREF(__pyx_v_g);
  return ((struct __pyx_obj_7py_pari_gen *)__pyx_r) ;
}

static PyObject *__pyx_n_isinstance;
static PyObject *__pyx_n_True;
static PyObject *__pyx_n_False;

static PyObject *__pyx_f_7py_pari_pari(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_pari[] = "\n    Create the PARI object got by evaluating s using PARI.\n    ";
static PyObject *__pyx_f_7py_pari_pari(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_s = 0;
  struct __pyx_obj_7py_pari_gen *__pyx_v_p;
  GEN __pyx_v_g;
  pari_sp __pyx_v_prev_avma;
  PyObject *__pyx_v_t;
  PyObject *__pyx_v_again;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  int __pyx_4;
  char (*__pyx_5);
  GEN __pyx_6;
  static char *__pyx_argnames[] = {"s",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_s)) return 0;
  Py_INCREF(__pyx_v_s);
  ((PyObject*)__pyx_v_p) = Py_None; Py_INCREF(((PyObject*)__pyx_v_p));
  __pyx_v_t = Py_None; Py_INCREF(__pyx_v_t);
  __pyx_v_again = Py_None; Py_INCREF(__pyx_v_again);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3001 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_isinstance); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3001; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(2); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3001; goto __pyx_L1;}
  Py_INCREF(__pyx_v_s);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_s);
  Py_INCREF(((PyObject*)__pyx_ptype_7py_pari_gen));
  PyTuple_SET_ITEM(__pyx_2, 1, ((PyObject*)__pyx_ptype_7py_pari_gen));
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3001; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  __pyx_4 = PyObject_IsTrue(__pyx_3); if (__pyx_4 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3001; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  if (__pyx_4) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3002 */
    Py_INCREF(__pyx_v_s);
    __pyx_r = __pyx_v_s;
    goto __pyx_L0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3004 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_str); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3004; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3004; goto __pyx_L1;}
  Py_INCREF(__pyx_v_s);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_s);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3004; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_v_t);
  __pyx_v_t = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3005 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_True); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3005; goto __pyx_L1;}
  Py_DECREF(__pyx_v_again);
  __pyx_v_again = __pyx_1;
  __pyx_1 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3006 */
  while (1) {
    __pyx_L3:;
    __pyx_4 = PyObject_IsTrue(__pyx_v_again); if (__pyx_4 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3006; goto __pyx_L1;}
    if (!__pyx_4) break;

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3007 */
    /*try:*/ {

      /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3009 */
      __pyx_2 = __pyx_f_7py_pari_save_avma(); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3009; goto __pyx_L5;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;

      /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3010 */
      __pyx_5 = PyString_AsString(__pyx_v_t); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3010; goto __pyx_L5;}
      __pyx_6 = __pyx_f_7py_pari_str_to_GEN(__pyx_5); if (__pyx_6 == 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3010; goto __pyx_L5;}
      __pyx_v_g = __pyx_6;

      /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3011 */
      __pyx_3 = __Pyx_GetName(__pyx_b, __pyx_n_False); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3011; goto __pyx_L5;}
      Py_DECREF(__pyx_v_again);
      __pyx_v_again = __pyx_3;
      __pyx_3 = 0;
    }
    goto __pyx_L6;
    __pyx_L5:;
    Py_XDECREF(__pyx_1); __pyx_1 = 0;
    Py_XDECREF(__pyx_2); __pyx_2 = 0;
    Py_XDECREF(__pyx_3); __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3012 */
    __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_MemoryError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3012; goto __pyx_L1;}
    __pyx_4 = PyErr_ExceptionMatches(__pyx_1);
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    if (__pyx_4) {
      __Pyx_AddTraceback("py_pari.pari");
      __pyx_2 = __Pyx_GetExcValue(); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3012; goto __pyx_L1;}
      Py_DECREF(__pyx_2); __pyx_2 = 0;

      /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3013 */
      __pyx_3 = __Pyx_GetName(__pyx_b, __pyx_n_True); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3013; goto __pyx_L1;}
      Py_DECREF(__pyx_v_again);
      __pyx_v_again = __pyx_3;
      __pyx_3 = 0;
      goto __pyx_L6;
    }
    goto __pyx_L1;
    __pyx_L6:;
  }
  __pyx_L4:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3014 */
  __pyx_1 = ((PyObject *)__pyx_f_7py_pari_new_gen(__pyx_v_g)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3014; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.pari");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_p);
  Py_DECREF(__pyx_v_t);
  Py_DECREF(__pyx_v_again);
  Py_DECREF(__pyx_v_s);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_stack_pointer(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_stack_pointer(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3018 */
  __pyx_1 = PyLong_FromUnsignedLong(avma); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3018; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.stack_pointer");
  __pyx_r = 0;
  __pyx_L0:;
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_stack_top(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_stack_top(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3021 */
  __pyx_1 = PyLong_FromUnsignedLong(top); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3021; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.stack_top");
  __pyx_r = 0;
  __pyx_L0:;
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_stack_bottom(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_stack_bottom(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3024 */
  __pyx_1 = PyLong_FromUnsignedLong(bot); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3024; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.stack_bottom");
  __pyx_r = 0;
  __pyx_L0:;
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_stack_size(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_stack_size[] = "\n    Stack size, in bytes\n    ";
static PyObject *__pyx_f_7py_pari_stack_size(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3031 */
  __pyx_1 = PyLong_FromUnsignedLong((top - bot)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3031; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.stack_size");
  __pyx_r = 0;
  __pyx_L0:;
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_stack_usage(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_stack_usage[] = "\n    How much memory in megabytes is currently being used on the PARI stack.\n    ";
static PyObject *__pyx_f_7py_pari_stack_usage(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3038 */
  __pyx_1 = PyLong_FromUnsignedLong((top - avma)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3038; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.stack_usage");
  __pyx_r = 0;
  __pyx_L0:;
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_stack_available(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_stack_available[] = "\n    How much memory in bytes is currently available on the PARI stack.\n    ";
static PyObject *__pyx_f_7py_pari_stack_available(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3045 */
  __pyx_1 = PyLong_FromUnsignedLong((avma - bot)); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3045; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("py_pari.stack_available");
  __pyx_r = 0;
  __pyx_L0:;
  return __pyx_r;
}

static PyObject *__pyx_k58p;

static char (__pyx_k58[]) = "\n";

static PyObject *__pyx_f_7py_pari_execute(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_execute(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_s = 0;
  int __pyx_v_n;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  char (*__pyx_5);
  static char *__pyx_argnames[] = {"s",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_s)) return 0;
  Py_INCREF(__pyx_v_s);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3054 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3055 */
  __pyx_1 = __pyx_v_n;
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3056 */
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3056; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3056; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3056; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    Py_INCREF(__pyx_v_s);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_v_s);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3056; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3057 */
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_execute); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3057; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(1); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3057; goto __pyx_L1;}
    Py_INCREF(__pyx_v_s);
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_v_s);
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3057; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3060 */
  __pyx_2 = PyNumber_Add(__pyx_v_s, __pyx_k58p); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3060; goto __pyx_L1;}
  Py_DECREF(__pyx_v_s);
  __pyx_v_s = __pyx_2;
  __pyx_2 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3061 */
  __pyx_5 = PyString_AsString(__pyx_v_s); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3061; goto __pyx_L1;}
  flisseq(__pyx_5);

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari.execute");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_s);
  return __pyx_r;
}

static PyObject *__pyx_k59p;

static char (__pyx_k59[]) = "\n";

static PyObject *__pyx_f_7py_pari_eval(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_eval(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_s = 0;
  int __pyx_v_n;
  GEN __pyx_v_x;
  char (*__pyx_v_c);
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  char (*__pyx_5);
  static char *__pyx_argnames[] = {"s",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_s)) return 0;
  Py_INCREF(__pyx_v_s);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3065 */
  __pyx_v_n = setjmp(GP_DATA->env);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3066 */
  __pyx_1 = __pyx_v_n;
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3067 */
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3067; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3067; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3067; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_3);
    Py_INCREF(__pyx_v_s);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_v_s);
    __pyx_3 = 0;
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3067; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3068 */
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_eval); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3068; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(1); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3068; goto __pyx_L1;}
    Py_INCREF(__pyx_v_s);
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_v_s);
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3068; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    __pyx_r = __pyx_3;
    __pyx_3 = 0;
    goto __pyx_L0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3074 */
  __pyx_2 = PyNumber_Add(__pyx_v_s, __pyx_k59p); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3074; goto __pyx_L1;}
  Py_DECREF(__pyx_v_s);
  __pyx_v_s = __pyx_2;
  __pyx_2 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3075 */
  __pyx_5 = PyString_AsString(__pyx_v_s); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3075; goto __pyx_L1;}
  __pyx_v_x = flisseq(__pyx_5);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3077 */
  __pyx_v_c = GENtostr(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3079 */
  cgiv(__pyx_v_x);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3081 */
  __pyx_4 = __Pyx_GetName(__pyx_b, __pyx_n_str); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3081; goto __pyx_L1;}
  __pyx_3 = PyString_FromString(__pyx_v_c); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3081; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3081; goto __pyx_L1;}
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_3);
  __pyx_3 = 0;
  __pyx_3 = PyObject_CallObject(__pyx_4, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3081; goto __pyx_L1;}
  Py_DECREF(__pyx_4); __pyx_4 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_v_s);
  __pyx_v_s = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3083 */
  free(__pyx_v_c);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3084 */
  Py_INCREF(__pyx_v_s);
  __pyx_r = __pyx_v_s;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari.eval");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_s);
  return __pyx_r;
}

static PyObject *__pyx_n_OverflowError;

static PyObject *__pyx_k60p;
static PyObject *__pyx_k61p;
static PyObject *__pyx_k62p;

static char (__pyx_k60[]) = "Pari ran out of memory; increasing the computation stack.";
static char (__pyx_k61[]) = "Object too big to fit in a codeword: %s";
static char (__pyx_k62[]) = "Pari error number %s: %s";

static PyObject *__pyx_f_7py_pari__error(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari__error(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_n = 0;
  PyObject *__pyx_v_s = 0;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  int __pyx_2;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {"n","s",0};
  __pyx_v_s = __pyx_k33;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O|O", __pyx_argnames, &__pyx_v_n, &__pyx_v_s)) return 0;
  Py_INCREF(__pyx_v_n);
  Py_INCREF(__pyx_v_s);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3087 */
  __pyx_1 = PyInt_FromLong(64); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3087; goto __pyx_L1;}
  if (PyObject_Cmp(__pyx_v_n, __pyx_1, &__pyx_2) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3087; goto __pyx_L1;}
  __pyx_2 = __pyx_2 == 0;
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  if (__pyx_2) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3088 */
    __pyx_2 = __pyx_f_7py_pari_init_stack(0); if (__pyx_2 == -1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3088; goto __pyx_L1;}

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3089 */
    __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_MemoryError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3089; goto __pyx_L1;}
    __Pyx_Raise(__pyx_1, __pyx_k60p, 0);
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3089; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3091 */
  __pyx_1 = PyInt_FromLong(65); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3091; goto __pyx_L1;}
  if (PyObject_Cmp(__pyx_v_n, __pyx_1, &__pyx_2) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3091; goto __pyx_L1;}
  __pyx_2 = __pyx_2 == 0;
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  if (__pyx_2) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3092 */
    __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_OverflowError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3092; goto __pyx_L1;}
    __pyx_3 = PyNumber_Remainder(__pyx_k61p, __pyx_v_s); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3092; goto __pyx_L1;}
    __Pyx_Raise(__pyx_1, __pyx_3, 0);
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3092; goto __pyx_L1;}
    goto __pyx_L3;
  }
  __pyx_L3:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3093 */
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_RuntimeError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3093; goto __pyx_L1;}
  __pyx_3 = PyTuple_New(2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3093; goto __pyx_L1;}
  Py_INCREF(__pyx_v_n);
  PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_n);
  Py_INCREF(__pyx_v_s);
  PyTuple_SET_ITEM(__pyx_3, 1, __pyx_v_s);
  __pyx_4 = PyNumber_Remainder(__pyx_k62p, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3093; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  __Pyx_Raise(__pyx_1, __pyx_4, 0);
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_4); __pyx_4 = 0;
  {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3093; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari._error");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_n);
  Py_DECREF(__pyx_v_s);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_min(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_min(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_x = 0;
  PyObject *__pyx_v_y = 0;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {"x","y",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "OO", __pyx_argnames, &__pyx_v_x, &__pyx_v_y)) return 0;
  Py_INCREF(__pyx_v_x);
  Py_INCREF(__pyx_v_y);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3098 */
  __pyx_1 = PyObject_GetAttr(__pyx_v_x, __pyx_n_min); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3098; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3098; goto __pyx_L1;}
  Py_INCREF(__pyx_v_y);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_y);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3098; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  __pyx_r = __pyx_3;
  __pyx_3 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.min");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  Py_DECREF(__pyx_v_y);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_max(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_max(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_x = 0;
  PyObject *__pyx_v_y = 0;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {"x","y",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "OO", __pyx_argnames, &__pyx_v_x, &__pyx_v_y)) return 0;
  Py_INCREF(__pyx_v_x);
  Py_INCREF(__pyx_v_y);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3101 */
  __pyx_1 = PyObject_GetAttr(__pyx_v_x, __pyx_n_max); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3101; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3101; goto __pyx_L1;}
  Py_INCREF(__pyx_v_y);
  PyTuple_SET_ITEM(__pyx_2, 0, __pyx_v_y);
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3101; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  __pyx_r = __pyx_3;
  __pyx_3 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("py_pari.max");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_x);
  Py_DECREF(__pyx_v_y);
  return __pyx_r;
}

static PyObject *__pyx_k63p;
static PyObject *__pyx_k64p;

static char (__pyx_k63[]) = "nth prime meaningless for negative n (=%s)";
static char (__pyx_k64[]) = "Not enough precomputed primes";

static PyObject *__pyx_f_7py_pari_nth_prime(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_7py_pari_nth_prime[] = "\n    nth_prime(n): returns the n-th prime, where n is a C-int\n    ";
static PyObject *__pyx_f_7py_pari_nth_prime(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  long __pyx_v_n;
  GEN __pyx_v_g;
  PyObject *__pyx_v_z;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {"n",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "l", __pyx_argnames, &__pyx_v_n)) return 0;
  __pyx_v_z = Py_None; Py_INCREF(__pyx_v_z);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3107 */
  __pyx_1 = (__pyx_v_n <= 0);
  if (__pyx_1) {

    /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3108 */
    __pyx_2 = __Pyx_GetName(__pyx_b, __pyx_n_ArithmeticError); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3108; goto __pyx_L1;}
    __pyx_3 = PyInt_FromLong(__pyx_v_n); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3108; goto __pyx_L1;}
    __pyx_4 = PyNumber_Remainder(__pyx_k63p, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3108; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __Pyx_Raise(__pyx_2, __pyx_4, 0);
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3108; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3110 */
  __pyx_3 = PyInt_FromLong(setjmp(GP_DATA->env)); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3110; goto __pyx_L1;}
  Py_DECREF(__pyx_v_z);
  __pyx_v_z = __pyx_3;
  __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3111 */
  __pyx_1 = PyObject_IsTrue(__pyx_v_z); if (__pyx_1 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3111; goto __pyx_L1;}
  if (__pyx_1) {
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n__error); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3111; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3111; goto __pyx_L1;}
    Py_INCREF(__pyx_v_z);
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_v_z);
    Py_INCREF(__pyx_k64p);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_k64p);
    __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3111; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    goto __pyx_L3;
  }
  __pyx_L3:;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3112 */
  __pyx_v_g = prime(__pyx_v_n);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3113 */
  __pyx_2 = ((PyObject *)__pyx_f_7py_pari_new_gen(__pyx_v_g)); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 3113; goto __pyx_L1;}
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("py_pari.nth_prime");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_z);
  return __pyx_r;
}

static PyObject *__pyx_f_7py_pari_init_primes(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyObject *__pyx_f_7py_pari_init_primes(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  unsigned long __pyx_v_maxnum;
  PyObject *__pyx_r;
  static char *__pyx_argnames[] = {"maxnum",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "l", __pyx_argnames, &__pyx_v_maxnum)) return 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3116 */
  initprimes(__pyx_v_maxnum);

  __pyx_r = Py_None; Py_INCREF(__pyx_r);
  goto __pyx_L0;
  __pyx_L1:;
  __Pyx_AddTraceback("py_pari.init_primes");
  __pyx_r = 0;
  __pyx_L0:;
  return __pyx_r;
}

static __Pyx_InternTabEntry __pyx_intern_tab[] = {
  {&__pyx_n_ArithmeticError, "ArithmeticError"},
  {&__pyx_n_False, "False"},
  {&__pyx_n_IndexError, "IndexError"},
  {&__pyx_n_KeyboardInterrupt, "KeyboardInterrupt"},
  {&__pyx_n_MemoryError, "MemoryError"},
  {&__pyx_n_NotImplementedError, "NotImplementedError"},
  {&__pyx_n_OverflowError, "OverflowError"},
  {&__pyx_n_RuntimeError, "RuntimeError"},
  {&__pyx_n_SIGINT, "SIGINT"},
  {&__pyx_n_True, "True"},
  {&__pyx_n_TypeError, "TypeError"},
  {&__pyx_n__error, "_error"},
  {&__pyx_n__max_prime, "_max_prime"},
  {&__pyx_n_eval, "eval"},
  {&__pyx_n_execute, "execute"},
  {&__pyx_n_find, "find"},
  {&__pyx_n_g, "g"},
  {&__pyx_n_gc, "gc"},
  {&__pyx_n_gens, "gens"},
  {&__pyx_n_init, "init"},
  {&__pyx_n_init_primes, "init_primes"},
  {&__pyx_n_initialized, "initialized"},
  {&__pyx_n_isinstance, "isinstance"},
  {&__pyx_n_isprime, "isprime"},
  {&__pyx_n_long, "long"},
  {&__pyx_n_max, "max"},
  {&__pyx_n_min, "min"},
  {&__pyx_n_my_sigint, "my_sigint"},
  {&__pyx_n_nth_prime, "nth_prime"},
  {&__pyx_n_pari, "pari"},
  {&__pyx_n_py_pari_py, "py_pari_py"},
  {&__pyx_n_replace, "replace"},
  {&__pyx_n_signal, "signal"},
  {&__pyx_n_stack_available, "stack_available"},
  {&__pyx_n_stack_bottom, "stack_bottom"},
  {&__pyx_n_stack_pointer, "stack_pointer"},
  {&__pyx_n_stack_size, "stack_size"},
  {&__pyx_n_stack_top, "stack_top"},
  {&__pyx_n_stack_usage, "stack_usage"},
  {&__pyx_n_str, "str"},
  {0, 0}
};

static __Pyx_StringTabEntry __pyx_string_tab[] = {
  {&__pyx_k32p, __pyx_k32, sizeof(__pyx_k32)},
  {&__pyx_k34p, __pyx_k34, sizeof(__pyx_k34)},
  {&__pyx_k35p, __pyx_k35, sizeof(__pyx_k35)},
  {&__pyx_k37p, __pyx_k37, sizeof(__pyx_k37)},
  {&__pyx_k39p, __pyx_k39, sizeof(__pyx_k39)},
  {&__pyx_k40p, __pyx_k40, sizeof(__pyx_k40)},
  {&__pyx_k41p, __pyx_k41, sizeof(__pyx_k41)},
  {&__pyx_k42p, __pyx_k42, sizeof(__pyx_k42)},
  {&__pyx_k43p, __pyx_k43, sizeof(__pyx_k43)},
  {&__pyx_k44p, __pyx_k44, sizeof(__pyx_k44)},
  {&__pyx_k45p, __pyx_k45, sizeof(__pyx_k45)},
  {&__pyx_k46p, __pyx_k46, sizeof(__pyx_k46)},
  {&__pyx_k47p, __pyx_k47, sizeof(__pyx_k47)},
  {&__pyx_k48p, __pyx_k48, sizeof(__pyx_k48)},
  {&__pyx_k49p, __pyx_k49, sizeof(__pyx_k49)},
  {&__pyx_k50p, __pyx_k50, sizeof(__pyx_k50)},
  {&__pyx_k51p, __pyx_k51, sizeof(__pyx_k51)},
  {&__pyx_k52p, __pyx_k52, sizeof(__pyx_k52)},
  {&__pyx_k53p, __pyx_k53, sizeof(__pyx_k53)},
  {&__pyx_k54p, __pyx_k54, sizeof(__pyx_k54)},
  {&__pyx_k55p, __pyx_k55, sizeof(__pyx_k55)},
  {&__pyx_k56p, __pyx_k56, sizeof(__pyx_k56)},
  {&__pyx_k57p, __pyx_k57, sizeof(__pyx_k57)},
  {&__pyx_k58p, __pyx_k58, sizeof(__pyx_k58)},
  {&__pyx_k59p, __pyx_k59, sizeof(__pyx_k59)},
  {&__pyx_k60p, __pyx_k60, sizeof(__pyx_k60)},
  {&__pyx_k61p, __pyx_k61, sizeof(__pyx_k61)},
  {&__pyx_k62p, __pyx_k62, sizeof(__pyx_k62)},
  {&__pyx_k63p, __pyx_k63, sizeof(__pyx_k63)},
  {&__pyx_k64p, __pyx_k64, sizeof(__pyx_k64)},
  {0, 0, 0}
};
static struct __pyx_vtabstruct_7py_pari_gen __pyx_vtable_7py_pari_gen;

static PyObject *__pyx_tp_new_7py_pari_gen(PyTypeObject *t, PyObject *a, PyObject *k) {
  PyObject *o = (*t->tp_alloc)(t, 0);
  struct __pyx_obj_7py_pari_gen *p = (struct __pyx_obj_7py_pari_gen *)o;
  (struct __pyx_vtabstruct_7py_pari_gen *)p->__pyx_vtab = __pyx_vtabptr_7py_pari_gen;
  p->refers_to = Py_None; Py_INCREF(p->refers_to);
  return o;
}

static void __pyx_tp_dealloc_7py_pari_gen(PyObject *o) {
  struct __pyx_obj_7py_pari_gen *p = (struct __pyx_obj_7py_pari_gen *)o;
  {
    PyObject *etype, *eval, *etb;
    PyErr_Fetch(&etype, &eval, &etb);
    ++o->ob_refcnt;
    __pyx_f_7py_pari_3gen___dealloc__(o);
    if (PyErr_Occurred()) PyErr_WriteUnraisable(o);
    --o->ob_refcnt;
    PyErr_Restore(etype, eval, etb);
  }
  Py_XDECREF(p->refers_to);
  (*o->ob_type->tp_free)(o);
}

static int __pyx_tp_traverse_7py_pari_gen(PyObject *o, visitproc v, void *a) {
  int e;
  struct __pyx_obj_7py_pari_gen *p = (struct __pyx_obj_7py_pari_gen *)o;
  if (p->refers_to) {
    e = (*v)(p->refers_to, a); if (e) return e;
  }
  return 0;
}

static int __pyx_tp_clear_7py_pari_gen(PyObject *o) {
  struct __pyx_obj_7py_pari_gen *p = (struct __pyx_obj_7py_pari_gen *)o;
  Py_XDECREF(p->refers_to);
  p->refers_to = Py_None; Py_INCREF(p->refers_to);
  return 0;
}
static PyObject *__pyx_sq_item_7py_pari_gen(PyObject *o, int i) {
  PyObject *r;
  PyObject *x = PyInt_FromLong(i); if(!x) return 0;
  r = o->ob_type->tp_as_mapping->mp_subscript(o, x);
  Py_DECREF(x);
  return r;
}

static int __pyx_mp_ass_subscript_7py_pari_gen(PyObject *o, PyObject *i, PyObject *v) {
  if (v) {
    return __pyx_f_7py_pari_3gen___setitem__(o, i, v);
  }
  else {
    PyErr_Format(PyExc_NotImplementedError,
      "Subscript deletion not supported by %s", o->ob_type->tp_name);
    return -1;
  }
}

static struct PyMethodDef __pyx_methods_7py_pari_gen[] = {
  {"__reduce__", (PyCFunction)__pyx_f_7py_pari_3gen___reduce__, METH_VARARGS|METH_KEYWORDS, 0},
  {"copy", (PyCFunction)__pyx_f_7py_pari_3gen_copy, METH_VARARGS|METH_KEYWORDS, 0},
  {"eval", (PyCFunction)__pyx_f_7py_pari_3gen_eval, METH_VARARGS|METH_KEYWORDS, 0},
  {"list", (PyCFunction)__pyx_f_7py_pari_3gen_list, METH_VARARGS|METH_KEYWORDS, 0},
  {"isprime", (PyCFunction)__pyx_f_7py_pari_3gen_isprime, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_isprime},
  {"divrem", (PyCFunction)__pyx_f_7py_pari_3gen_divrem, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_divrem},
  {"lex", (PyCFunction)__pyx_f_7py_pari_3gen_lex, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_lex},
  {"max", (PyCFunction)__pyx_f_7py_pari_3gen_max, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_max},
  {"min", (PyCFunction)__pyx_f_7py_pari_3gen_min, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_min},
  {"shift", (PyCFunction)__pyx_f_7py_pari_3gen_shift, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_shift},
  {"shiftmul", (PyCFunction)__pyx_f_7py_pari_3gen_shiftmul, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_shiftmul},
  {"sign", (PyCFunction)__pyx_f_7py_pari_3gen_sign, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_sign},
  {"vecmax", (PyCFunction)__pyx_f_7py_pari_3gen_vecmax, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_vecmax},
  {"vecmin", (PyCFunction)__pyx_f_7py_pari_3gen_vecmin, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_vecmin},
  {"Col", (PyCFunction)__pyx_f_7py_pari_3gen_Col, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_Col},
  {"List", (PyCFunction)__pyx_f_7py_pari_3gen_List, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_List},
  {"Mat", (PyCFunction)__pyx_f_7py_pari_3gen_Mat, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_Mat},
  {"Mod", (PyCFunction)__pyx_f_7py_pari_3gen_Mod, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_Mod},
  {"Pol", (PyCFunction)__pyx_f_7py_pari_3gen_Pol, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_Pol},
  {"Polrev", (PyCFunction)__pyx_f_7py_pari_3gen_Polrev, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_Polrev},
  {"Qfb", (PyCFunction)__pyx_f_7py_pari_3gen_Qfb, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_Qfb},
  {"Ser", (PyCFunction)__pyx_f_7py_pari_3gen_Ser, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_Ser},
  {"Set", (PyCFunction)__pyx_f_7py_pari_3gen_Set, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_Set},
  {"Str", (PyCFunction)__pyx_f_7py_pari_3gen_Str, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_Str},
  {"Strchr", (PyCFunction)__pyx_f_7py_pari_3gen_Strchr, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_Strchr},
  {"Strexpand", (PyCFunction)__pyx_f_7py_pari_3gen_Strexpand, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_Strexpand},
  {"Strtex", (PyCFunction)__pyx_f_7py_pari_3gen_Strtex, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_Strtex},
  {"Vec", (PyCFunction)__pyx_f_7py_pari_3gen_Vec, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_Vec},
  {"Vecsmall", (PyCFunction)__pyx_f_7py_pari_3gen_Vecsmall, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_Vecsmall},
  {"binary", (PyCFunction)__pyx_f_7py_pari_3gen_binary, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_binary},
  {"bitand", (PyCFunction)__pyx_f_7py_pari_3gen_bitand, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_bitand},
  {"bitneg", (PyCFunction)__pyx_f_7py_pari_3gen_bitneg, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_bitneg},
  {"bitnegimply", (PyCFunction)__pyx_f_7py_pari_3gen_bitnegimply, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_bitnegimply},
  {"bitor", (PyCFunction)__pyx_f_7py_pari_3gen_bitor, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_bitor},
  {"bittest", (PyCFunction)__pyx_f_7py_pari_3gen_bittest, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_bittest},
  {"bitxor", (PyCFunction)__pyx_f_7py_pari_3gen_bitxor, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_bitxor},
  {"ceil", (PyCFunction)__pyx_f_7py_pari_3gen_ceil, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_ceil},
  {"centerlift", (PyCFunction)__pyx_f_7py_pari_3gen_centerlift, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_centerlift},
  {"changevar", (PyCFunction)__pyx_f_7py_pari_3gen_changevar, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_changevar},
  {"component", (PyCFunction)__pyx_f_7py_pari_3gen_component, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_component},
  {"conj", (PyCFunction)__pyx_f_7py_pari_3gen_conj, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_conj},
  {"conjvec", (PyCFunction)__pyx_f_7py_pari_3gen_conjvec, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_conjvec},
  {"denominator", (PyCFunction)__pyx_f_7py_pari_3gen_denominator, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_denominator},
  {"floor", (PyCFunction)__pyx_f_7py_pari_3gen_floor, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_floor},
  {"frac", (PyCFunction)__pyx_f_7py_pari_3gen_frac, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_frac},
  {"imag", (PyCFunction)__pyx_f_7py_pari_3gen_imag, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_imag},
  {"length", (PyCFunction)__pyx_f_7py_pari_3gen_length, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_length},
  {"lift", (PyCFunction)__pyx_f_7py_pari_3gen_lift, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_lift},
  {"norm", (PyCFunction)__pyx_f_7py_pari_3gen_norm, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_norm},
  {"norml2", (PyCFunction)__pyx_f_7py_pari_3gen_norml2, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_norml2},
  {"numerator", (PyCFunction)__pyx_f_7py_pari_3gen_numerator, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_numerator},
  {"numtoperm", (PyCFunction)__pyx_f_7py_pari_3gen_numtoperm, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_numtoperm},
  {"padicprec", (PyCFunction)__pyx_f_7py_pari_3gen_padicprec, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_padicprec},
  {"permtonum", (PyCFunction)__pyx_f_7py_pari_3gen_permtonum, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_permtonum},
  {"precision", (PyCFunction)__pyx_f_7py_pari_3gen_precision, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_precision},
  {"random", (PyCFunction)__pyx_f_7py_pari_3gen_random, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_random},
  {"real", (PyCFunction)__pyx_f_7py_pari_3gen_real, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_real},
  {"round", (PyCFunction)__pyx_f_7py_pari_3gen_round, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_round},
  {"simplify", (PyCFunction)__pyx_f_7py_pari_3gen_simplify, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_simplify},
  {"sizebyte", (PyCFunction)__pyx_f_7py_pari_3gen_sizebyte, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_sizebyte},
  {"sizedigit", (PyCFunction)__pyx_f_7py_pari_3gen_sizedigit, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_sizedigit},
  {"truncate", (PyCFunction)__pyx_f_7py_pari_3gen_truncate, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_truncate},
  {"valuation", (PyCFunction)__pyx_f_7py_pari_3gen_valuation, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_valuation},
  {"variable", (PyCFunction)__pyx_f_7py_pari_3gen_variable, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_variable},
  {"elladd", (PyCFunction)__pyx_f_7py_pari_3gen_elladd, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_elladd},
  {"ellak", (PyCFunction)__pyx_f_7py_pari_3gen_ellak, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_ellak},
  {"ellan", (PyCFunction)__pyx_f_7py_pari_3gen_ellan, METH_VARARGS|METH_KEYWORDS, 0},
  {"ellap", (PyCFunction)__pyx_f_7py_pari_3gen_ellap, METH_VARARGS|METH_KEYWORDS, 0},
  {"ellbil", (PyCFunction)__pyx_f_7py_pari_3gen_ellbil, METH_VARARGS|METH_KEYWORDS, 0},
  {"ellchangecurve", (PyCFunction)__pyx_f_7py_pari_3gen_ellchangecurve, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_ellchangecurve},
  {"ellchangepoint", (PyCFunction)__pyx_f_7py_pari_3gen_ellchangepoint, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_ellchangepoint},
  {"elleisnum", (PyCFunction)__pyx_f_7py_pari_3gen_elleisnum, METH_VARARGS|METH_KEYWORDS, 0},
  {"elleta", (PyCFunction)__pyx_f_7py_pari_3gen_elleta, METH_VARARGS|METH_KEYWORDS, 0},
  {"ellglobalred", (PyCFunction)__pyx_f_7py_pari_3gen_ellglobalred, METH_VARARGS|METH_KEYWORDS, 0},
  {"ellheight", (PyCFunction)__pyx_f_7py_pari_3gen_ellheight, METH_VARARGS|METH_KEYWORDS, 0},
  {"ellheightmatrix", (PyCFunction)__pyx_f_7py_pari_3gen_ellheightmatrix, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_ellheightmatrix},
  {"ellinit", (PyCFunction)__pyx_f_7py_pari_3gen_ellinit, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_3gen_ellinit},
  {"ellisoncurve", (PyCFunction)__pyx_f_7py_pari_3gen_ellisoncurve, METH_VARARGS|METH_KEYWORDS, 0},
  {"ellj", (PyCFunction)__pyx_f_7py_pari_3gen_ellj, METH_VARARGS|METH_KEYWORDS, 0},
  {"elllocalred", (PyCFunction)__pyx_f_7py_pari_3gen_elllocalred, METH_VARARGS|METH_KEYWORDS, 0},
  {"elllseries", (PyCFunction)__pyx_f_7py_pari_3gen_elllseries, METH_VARARGS|METH_KEYWORDS, 0},
  {"ellminimalmodel", (PyCFunction)__pyx_f_7py_pari_3gen_ellminimalmodel, METH_VARARGS|METH_KEYWORDS, 0},
  {"ellorder", (PyCFunction)__pyx_f_7py_pari_3gen_ellorder, METH_VARARGS|METH_KEYWORDS, 0},
  {"ellordinate", (PyCFunction)__pyx_f_7py_pari_3gen_ellordinate, METH_VARARGS|METH_KEYWORDS, 0},
  {"ellpointtoz", (PyCFunction)__pyx_f_7py_pari_3gen_ellpointtoz, METH_VARARGS|METH_KEYWORDS, 0},
  {"ellpow", (PyCFunction)__pyx_f_7py_pari_3gen_ellpow, METH_VARARGS|METH_KEYWORDS, 0},
  {"ellrootno", (PyCFunction)__pyx_f_7py_pari_3gen_ellrootno, METH_VARARGS|METH_KEYWORDS, 0},
  {"ellsigma", (PyCFunction)__pyx_f_7py_pari_3gen_ellsigma, METH_VARARGS|METH_KEYWORDS, 0},
  {"ellsub", (PyCFunction)__pyx_f_7py_pari_3gen_ellsub, METH_VARARGS|METH_KEYWORDS, 0},
  {"elltaniyama", (PyCFunction)__pyx_f_7py_pari_3gen_elltaniyama, METH_VARARGS|METH_KEYWORDS, 0},
  {"elltors", (PyCFunction)__pyx_f_7py_pari_3gen_elltors, METH_VARARGS|METH_KEYWORDS, 0},
  {"ellwp", (PyCFunction)__pyx_f_7py_pari_3gen_ellwp, METH_VARARGS|METH_KEYWORDS, 0},
  {"ellzeta", (PyCFunction)__pyx_f_7py_pari_3gen_ellzeta, METH_VARARGS|METH_KEYWORDS, 0},
  {"ellztopoint", (PyCFunction)__pyx_f_7py_pari_3gen_ellztopoint, METH_VARARGS|METH_KEYWORDS, 0},
  {"factor", (PyCFunction)__pyx_f_7py_pari_3gen_factor, METH_VARARGS|METH_KEYWORDS, 0},
  {"exp", (PyCFunction)__pyx_f_7py_pari_3gen_exp, METH_VARARGS|METH_KEYWORDS, 0},
  {"log", (PyCFunction)__pyx_f_7py_pari_3gen_log, METH_VARARGS|METH_KEYWORDS, 0},
  {"type", (PyCFunction)__pyx_f_7py_pari_3gen_type, METH_VARARGS|METH_KEYWORDS, 0},
  {0, 0, 0, 0}
};

static PyNumberMethods __pyx_tp_as_number_gen = {
  __pyx_f_7py_pari_3gen___add__, /*nb_add*/
  __pyx_f_7py_pari_3gen___sub__, /*nb_subtract*/
  __pyx_f_7py_pari_3gen___mul__, /*nb_multiply*/
  __pyx_f_7py_pari_3gen___div__, /*nb_divide*/
  __pyx_f_7py_pari_3gen___mod__, /*nb_remainder*/
  0, /*nb_divmod*/
  __pyx_f_7py_pari_3gen___pow__, /*nb_power*/
  __pyx_f_7py_pari_3gen___neg__, /*nb_negative*/
  0, /*nb_positive*/
  0, /*nb_absolute*/
  0, /*nb_nonzero*/
  __pyx_f_7py_pari_3gen___invert__, /*nb_invert*/
  __pyx_f_7py_pari_3gen___lshift__, /*nb_lshift*/
  __pyx_f_7py_pari_3gen___rshift__, /*nb_rshift*/
  0, /*nb_and*/
  0, /*nb_xor*/
  0, /*nb_or*/
  0, /*nb_coerce*/
  __pyx_f_7py_pari_3gen___int__, /*nb_int*/
  __pyx_f_7py_pari_3gen___long__, /*nb_long*/
  __pyx_f_7py_pari_3gen___float__, /*nb_float*/
  0, /*nb_oct*/
  0, /*nb_hex*/
  0, /*nb_inplace_add*/
  0, /*nb_inplace_subtract*/
  0, /*nb_inplace_multiply*/
  0, /*nb_inplace_divide*/
  0, /*nb_inplace_remainder*/
  0, /*nb_inplace_power*/
  0, /*nb_inplace_lshift*/
  0, /*nb_inplace_rshift*/
  0, /*nb_inplace_and*/
  0, /*nb_inplace_xor*/
  0, /*nb_inplace_or*/
  0, /*nb_floor_divide*/
  0, /*nb_true_divide*/
  0, /*nb_inplace_floor_divide*/
  0, /*nb_inplace_true_divide*/
};

static PySequenceMethods __pyx_tp_as_sequence_gen = {
  __pyx_f_7py_pari_3gen___len__, /*sq_length*/
  0, /*sq_concat*/
  0, /*sq_repeat*/
  __pyx_sq_item_7py_pari_gen, /*sq_item*/
  __pyx_f_7py_pari_3gen___getslice__, /*sq_slice*/
  0, /*sq_ass_item*/
  0, /*sq_ass_slice*/
  0, /*sq_contains*/
  0, /*sq_inplace_concat*/
  0, /*sq_inplace_repeat*/
};

static PyMappingMethods __pyx_tp_as_mapping_gen = {
  __pyx_f_7py_pari_3gen___len__, /*mp_length*/
  __pyx_f_7py_pari_3gen___getitem__, /*mp_subscript*/
  __pyx_mp_ass_subscript_7py_pari_gen, /*mp_ass_subscript*/
};

static PyBufferProcs __pyx_tp_as_buffer_gen = {
  0, /*bf_getreadbuffer*/
  0, /*bf_getwritebuffer*/
  0, /*bf_getsegcount*/
  0, /*bf_getcharbuffer*/
};

statichere PyTypeObject __pyx_type_7py_pari_gen = {
  PyObject_HEAD_INIT(0)
  0, /*ob_size*/
  "py_pari.gen", /*tp_name*/
  sizeof(struct __pyx_obj_7py_pari_gen), /*tp_basicsize*/
  0, /*tp_itemsize*/
  __pyx_tp_dealloc_7py_pari_gen, /*tp_dealloc*/
  0, /*tp_print*/
  0, /*tp_getattr*/
  0, /*tp_setattr*/
  __pyx_f_7py_pari_3gen___cmp__, /*tp_compare*/
  __pyx_f_7py_pari_3gen___repr__, /*tp_repr*/
  &__pyx_tp_as_number_gen, /*tp_as_number*/
  &__pyx_tp_as_sequence_gen, /*tp_as_sequence*/
  &__pyx_tp_as_mapping_gen, /*tp_as_mapping*/
  0, /*tp_hash*/
  0, /*tp_call*/
  0, /*tp_str*/
  0, /*tp_getattro*/
  0, /*tp_setattro*/
  &__pyx_tp_as_buffer_gen, /*tp_as_buffer*/
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_CHECKTYPES|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC, /*tp_flags*/
  0, /*tp_doc*/
  __pyx_tp_traverse_7py_pari_gen, /*tp_traverse*/
  __pyx_tp_clear_7py_pari_gen, /*tp_clear*/
  0, /*tp_richcompare*/
  0, /*tp_weaklistoffset*/
  0, /*tp_iter*/
  0, /*tp_iternext*/
  __pyx_methods_7py_pari_gen, /*tp_methods*/
  0, /*tp_members*/
  0, /*tp_getset*/
  0, /*tp_base*/
  0, /*tp_dict*/
  0, /*tp_descr_get*/
  0, /*tp_descr_set*/
  0, /*tp_dictoffset*/
  0, /*tp_init*/
  0, /*tp_alloc*/
  __pyx_tp_new_7py_pari_gen, /*tp_new*/
  0, /*tp_free*/
  0, /*tp_is_gc*/
  0, /*tp_bases*/
  0, /*tp_mro*/
  0, /*tp_cache*/
  0, /*tp_subclasses*/
  0, /*tp_weaklist*/
};

static struct PyMethodDef __pyx_methods[] = {
  {"my_sigint", (PyCFunction)__pyx_f_7py_pari_my_sigint, METH_VARARGS|METH_KEYWORDS, 0},
  {"init", (PyCFunction)__pyx_f_7py_pari_init, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_init},
  {"pari", (PyCFunction)__pyx_f_7py_pari_pari, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_pari},
  {"stack_pointer", (PyCFunction)__pyx_f_7py_pari_stack_pointer, METH_VARARGS|METH_KEYWORDS, 0},
  {"stack_top", (PyCFunction)__pyx_f_7py_pari_stack_top, METH_VARARGS|METH_KEYWORDS, 0},
  {"stack_bottom", (PyCFunction)__pyx_f_7py_pari_stack_bottom, METH_VARARGS|METH_KEYWORDS, 0},
  {"stack_size", (PyCFunction)__pyx_f_7py_pari_stack_size, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_stack_size},
  {"stack_usage", (PyCFunction)__pyx_f_7py_pari_stack_usage, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_stack_usage},
  {"stack_available", (PyCFunction)__pyx_f_7py_pari_stack_available, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_stack_available},
  {"execute", (PyCFunction)__pyx_f_7py_pari_execute, METH_VARARGS|METH_KEYWORDS, 0},
  {"eval", (PyCFunction)__pyx_f_7py_pari_eval, METH_VARARGS|METH_KEYWORDS, 0},
  {"_error", (PyCFunction)__pyx_f_7py_pari__error, METH_VARARGS|METH_KEYWORDS, 0},
  {"min", (PyCFunction)__pyx_f_7py_pari_min, METH_VARARGS|METH_KEYWORDS, 0},
  {"max", (PyCFunction)__pyx_f_7py_pari_max, METH_VARARGS|METH_KEYWORDS, 0},
  {"nth_prime", (PyCFunction)__pyx_f_7py_pari_nth_prime, METH_VARARGS|METH_KEYWORDS, __pyx_doc_7py_pari_nth_prime},
  {"init_primes", (PyCFunction)__pyx_f_7py_pari_init_primes, METH_VARARGS|METH_KEYWORDS, 0},
  {0, 0, 0, 0}
};

DL_EXPORT(void) initpy_pari(void); /*proto*/
DL_EXPORT(void) initpy_pari(void) {
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  PyObject *__pyx_5 = 0;
  PyObject *__pyx_6 = 0;
  PyObject *__pyx_7 = 0;
  PyObject *__pyx_8 = 0;
  PyObject *__pyx_9 = 0;
  PyObject *__pyx_10 = 0;
  PyObject *__pyx_11 = 0;
  PyObject *__pyx_12 = 0;
  PyObject *__pyx_13 = 0;
  PyObject *__pyx_14 = 0;
  PyObject *__pyx_15 = 0;
  __pyx_m = Py_InitModule4("py_pari", __pyx_methods, __pyx_mdoc, 0, PYTHON_API_VERSION);
  if (!__pyx_m) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1; goto __pyx_L1;};
  __pyx_b = PyImport_AddModule("__builtin__");
  if (!__pyx_b) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1; goto __pyx_L1;};
  if (PyObject_SetAttrString(__pyx_m, "__builtins__", __pyx_b) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1; goto __pyx_L1;};
  if (__Pyx_InternStrings(__pyx_intern_tab) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1; goto __pyx_L1;};
  if (__Pyx_InitStrings(__pyx_string_tab) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1; goto __pyx_L1;};
  ((PyObject*)__pyx_v_7py_pari_ZERO) = Py_None; Py_INCREF(((PyObject*)__pyx_v_7py_pari_ZERO));
  ((PyObject*)__pyx_v_7py_pari_ONE) = Py_None; Py_INCREF(((PyObject*)__pyx_v_7py_pari_ONE));
  ((PyObject*)__pyx_v_7py_pari_TWO) = Py_None; Py_INCREF(((PyObject*)__pyx_v_7py_pari_TWO));
  __pyx_vtabptr_7py_pari_gen = &__pyx_vtable_7py_pari_gen;
  __pyx_vtable_7py_pari_gen.init = (void *)__pyx_f_7py_pari_3gen_init;
  __pyx_vtable_7py_pari_gen._gen = (void *)__pyx_f_7py_pari_3gen__gen;
  __pyx_type_7py_pari_gen.tp_free = _PyObject_GC_Del;
  if (PyType_Ready(&__pyx_type_7py_pari_gen) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2085; goto __pyx_L1;}
  if (__Pyx_SetVtable(__pyx_type_7py_pari_gen.tp_dict, __pyx_vtabptr_7py_pari_gen) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2085; goto __pyx_L1;}
  if (PyObject_SetAttrString(__pyx_m, "gen", (PyObject *)&__pyx_type_7py_pari_gen) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2085; goto __pyx_L1;}
  __pyx_ptype_7py_pari_gen = &__pyx_type_7py_pari_gen;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":44 */
  __pyx_1 = __Pyx_Import(__pyx_n_gc, 0); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 44; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_gc, __pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 44; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":47 */
  __pyx_v_7py_pari_PREC = 32;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":1929 */
  GP_DATA = (&__pyx_v_7py_pari___GP_DATA);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":1994 */
  __pyx_1 = PyInt_FromLong(0); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1994; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_initialized, __pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1994; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":1995 */
  __pyx_1 = PyInt_FromLong(0); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1995; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n__max_prime, __pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1995; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":1996 */
  top = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":1997 */
  bot = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":1998 */
  avma = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":1999 */
  __pyx_k2 = 20000000;
  __pyx_k3 = 2000000;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2048 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_init); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2048; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2048; goto __pyx_L1;}
  __pyx_3 = PyObject_CallObject(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2048; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_3); __pyx_3 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2079 */
  __pyx_1 = PyList_New(0); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2079; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_gens, __pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2079; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2241 */
  __pyx_2 = PyInt_FromLong(0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2241; goto __pyx_L1;}
  __pyx_k4 = __pyx_2;
  __pyx_2 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2260 */
  __pyx_k5 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2472 */
  Py_INCREF(((PyObject *)__pyx_v_7py_pari_ZERO));
  __pyx_k6 = ((PyObject *)__pyx_v_7py_pari_ZERO);
  __pyx_k7 = __pyx_v_7py_pari_PREC;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2797 */
  __pyx_3 = PyInt_FromLong(0); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2797; goto __pyx_L1;}
  __pyx_k8 = __pyx_3;
  __pyx_3 = 0;
  __pyx_1 = PyInt_FromLong(__pyx_v_7py_pari_PREC); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2797; goto __pyx_L1;}
  __pyx_k9 = __pyx_1;
  __pyx_1 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2800 */
  __pyx_4 = PyInt_FromLong(__pyx_v_7py_pari_PREC); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2800; goto __pyx_L1;}
  __pyx_k10 = __pyx_4;
  __pyx_4 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2806 */
  __pyx_5 = PyInt_FromLong(0); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2806; goto __pyx_L1;}
  __pyx_k11 = __pyx_5;
  __pyx_5 = 0;
  __pyx_6 = PyInt_FromLong(__pyx_v_7py_pari_PREC); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2806; goto __pyx_L1;}
  __pyx_k12 = __pyx_6;
  __pyx_6 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2809 */
  __pyx_k13 = __pyx_v_7py_pari_PREC;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2823 */
  __pyx_7 = PyInt_FromLong(0); if (!__pyx_7) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2823; goto __pyx_L1;}
  __pyx_k14 = __pyx_7;
  __pyx_7 = 0;
  __pyx_8 = PyInt_FromLong(__pyx_v_7py_pari_PREC); if (!__pyx_8) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2823; goto __pyx_L1;}
  __pyx_k15 = __pyx_8;
  __pyx_8 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2841 */
  __pyx_k16 = __pyx_v_7py_pari_PREC;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2847 */
  Py_INCREF(((PyObject *)__pyx_v_7py_pari_ONE));
  __pyx_k17 = ((PyObject *)__pyx_v_7py_pari_ONE);
  __pyx_k18 = 4;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2860 */
  __pyx_k19 = __pyx_v_7py_pari_PREC;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2863 */
  __pyx_k20 = __pyx_v_7py_pari_PREC;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2869 */
  Py_INCREF(((PyObject *)__pyx_v_7py_pari_ONE));
  __pyx_k21 = ((PyObject *)__pyx_v_7py_pari_ONE);

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2872 */
  __pyx_9 = PyInt_FromLong(0); if (!__pyx_9) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2872; goto __pyx_L1;}
  __pyx_k22 = __pyx_9;
  __pyx_9 = 0;
  __pyx_10 = PyInt_FromLong(__pyx_v_7py_pari_PREC); if (!__pyx_10) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2872; goto __pyx_L1;}
  __pyx_k23 = __pyx_10;
  __pyx_10 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2881 */
  __pyx_11 = PyInt_FromLong(0); if (!__pyx_11) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2881; goto __pyx_L1;}
  __pyx_k24 = __pyx_11;
  __pyx_11 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2884 */
  __pyx_k25 = 0;
  __pyx_k26 = __pyx_v_7py_pari_PREC;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2887 */
  __pyx_k27 = __pyx_v_7py_pari_PREC;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2890 */
  __pyx_k28 = __pyx_v_7py_pari_PREC;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2918 */
  __pyx_12 = PyInt_FromLong((-1)); if (!__pyx_12) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2918; goto __pyx_L1;}
  __pyx_k29 = __pyx_12;
  __pyx_12 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2925 */
  __pyx_13 = PyInt_FromLong(__pyx_v_7py_pari_PREC); if (!__pyx_13) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2925; goto __pyx_L1;}
  __pyx_k30 = __pyx_13;
  __pyx_13 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2928 */
  __pyx_14 = PyInt_FromLong(__pyx_v_7py_pari_PREC); if (!__pyx_14) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2928; goto __pyx_L1;}
  __pyx_k31 = __pyx_14;
  __pyx_14 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2939 */
  __pyx_15 = ((PyObject *)__pyx_f_7py_pari_new_gen(stoi(0))); if (!__pyx_15) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2939; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v_7py_pari_ZERO));
  ((PyObject *)__pyx_v_7py_pari_ZERO) = __pyx_15;
  __pyx_15 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2940 */
  __pyx_15 = ((PyObject *)__pyx_f_7py_pari_new_gen(stoi(1))); if (!__pyx_15) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2940; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v_7py_pari_ONE));
  ((PyObject *)__pyx_v_7py_pari_ONE) = __pyx_15;
  __pyx_15 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2941 */
  __pyx_15 = ((PyObject *)__pyx_f_7py_pari_new_gen(stoi(2))); if (!__pyx_15) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 2941; goto __pyx_L1;}
  Py_DECREF(((PyObject *)__pyx_v_7py_pari_TWO));
  ((PyObject *)__pyx_v_7py_pari_TWO) = __pyx_15;
  __pyx_15 = 0;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":2948 */
  __pyx_v_7py_pari_stack_avma = avma;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3086 */
  Py_INCREF(__pyx_k32p);
  __pyx_k33 = __pyx_k32p;

  /* "/home/was/sage/src/scripts/build-tmp/py_pari.pyx":3115 */
  return;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  Py_XDECREF(__pyx_5);
  Py_XDECREF(__pyx_6);
  Py_XDECREF(__pyx_7);
  Py_XDECREF(__pyx_8);
  Py_XDECREF(__pyx_9);
  Py_XDECREF(__pyx_10);
  Py_XDECREF(__pyx_11);
  Py_XDECREF(__pyx_12);
  Py_XDECREF(__pyx_13);
  Py_XDECREF(__pyx_14);
  Py_XDECREF(__pyx_15);
  __Pyx_AddTraceback("py_pari");
}

static char *__pyx_filenames[] = {
  "py_pari.pyx",
};
statichere char **__pyx_f = __pyx_filenames;

/* Runtime support code */

static int __Pyx_ArgTypeTest(PyObject *obj, PyTypeObject *type, int none_allowed, char *name) {
    if (!type) {
        PyErr_Format(PyExc_SystemError, "Missing type object");
        return 0;
    }
    if ((none_allowed && obj == Py_None) || PyObject_TypeCheck(obj, type))
        return 1;
    PyErr_Format(PyExc_TypeError,
        "Argument '%s' has incorrect type (expected %s, got %s)",
        name, type->tp_name, obj->ob_type->tp_name);
    return 0;
}

static PyObject *__Pyx_Import(PyObject *name, PyObject *from_list) {
    PyObject *__import__ = 0;
    PyObject *empty_list = 0;
    PyObject *module = 0;
    PyObject *global_dict = 0;
    PyObject *empty_dict = 0;
    PyObject *list;
    __import__ = PyObject_GetAttrString(__pyx_b, "__import__");
    if (!__import__)
        goto bad;
    if (from_list)
        list = from_list;
    else {
        empty_list = PyList_New(0);
        if (!empty_list)
            goto bad;
        list = empty_list;
    }
    global_dict = PyModule_GetDict(__pyx_m);
    if (!global_dict)
        goto bad;
    empty_dict = PyDict_New();
    if (!empty_dict)
        goto bad;
    module = PyObject_CallFunction(__import__, "OOOO",
        name, global_dict, empty_dict, list);
bad:
    Py_XDECREF(empty_list);
    Py_XDECREF(__import__);
    Py_XDECREF(empty_dict);
    return module;
}

static PyObject *__Pyx_GetName(PyObject *dict, PyObject *name) {
    PyObject *result;
    result = PyObject_GetAttr(dict, name);
    if (!result)
        PyErr_SetObject(PyExc_NameError, name);
    return result;
}

static void __Pyx_WriteUnraisable(char *name) {
    PyObject *old_exc, *old_val, *old_tb;
    PyObject *ctx;
    PyErr_Fetch(&old_exc, &old_val, &old_tb);
    ctx = PyString_FromString(name);
    PyErr_Restore(old_exc, old_val, old_tb);
    if (!ctx)
        ctx = Py_None;
    PyErr_WriteUnraisable(ctx);
}

static void __Pyx_Raise(PyObject *type, PyObject *value, PyObject *tb) {
    Py_XINCREF(type);
    Py_XINCREF(value);
    Py_XINCREF(tb);
    /* First, check the traceback argument, replacing None with NULL. */
    if (tb == Py_None) {
        Py_DECREF(tb);
        tb = 0;
    }
    else if (tb != NULL && !PyTraceBack_Check(tb)) {
        PyErr_SetString(PyExc_TypeError,
            "raise: arg 3 must be a traceback or None");
        goto raise_error;
    }
    /* Next, replace a missing value with None */
    if (value == NULL) {
        value = Py_None;
        Py_INCREF(value);
    }
    /* Next, repeatedly, replace a tuple exception with its first item */
    while (PyTuple_Check(type) && PyTuple_Size(type) > 0) {
        PyObject *tmp = type;
        type = PyTuple_GET_ITEM(type, 0);
        Py_INCREF(type);
        Py_DECREF(tmp);
    }
    if (PyString_Check(type))
        ;
    else if (PyClass_Check(type))
        ; /*PyErr_NormalizeException(&type, &value, &tb);*/
    else if (PyInstance_Check(type)) {
        /* Raising an instance.  The value should be a dummy. */
        if (value != Py_None) {
            PyErr_SetString(PyExc_TypeError,
              "instance exception may not have a separate value");
            goto raise_error;
        }
        else {
            /* Normalize to raise <class>, <instance> */
            Py_DECREF(value);
            value = type;
            type = (PyObject*) ((PyInstanceObject*)type)->in_class;
            Py_INCREF(type);
        }
    }
    else {
        /* Not something you can raise.  You get an exception
           anyway, just not what you specified :-) */
        PyErr_Format(PyExc_TypeError,
                 "exceptions must be strings, classes, or "
                 "instances, not %s", type->ob_type->tp_name);
        goto raise_error;
    }
    PyErr_Restore(type, value, tb);
    return;
raise_error:
    Py_XDECREF(value);
    Py_XDECREF(type);
    Py_XDECREF(tb);
    return;
}

static int __Pyx_TypeTest(PyObject *obj, PyTypeObject *type) {
    if (!type) {
        PyErr_Format(PyExc_SystemError, "Missing type object");
        return 0;
    }
    if (obj == Py_None || PyObject_TypeCheck(obj, type))
        return 1;
    PyErr_Format(PyExc_TypeError, "Cannot convert %s to %s",
        obj->ob_type->tp_name, type->tp_name);
    return 0;
}

static PyObject *__Pyx_GetExcValue(void) {
    PyObject *type = 0, *value = 0, *tb = 0;
    PyObject *result = 0;
    PyThreadState *tstate = PyThreadState_Get();
    PyErr_Fetch(&type, &value, &tb);
    PyErr_NormalizeException(&type, &value, &tb);
    if (PyErr_Occurred())
        goto bad;
    if (!value) {
        value = Py_None;
        Py_INCREF(value);
    }
    Py_XDECREF(tstate->exc_type);
    Py_XDECREF(tstate->exc_value);
    Py_XDECREF(tstate->exc_traceback);
    tstate->exc_type = type;
    tstate->exc_value = value;
    tstate->exc_traceback = tb;
    result = value;
    Py_XINCREF(result);
    type = 0;
    value = 0;
    tb = 0;
bad:
    Py_XDECREF(type);
    Py_XDECREF(value);
    Py_XDECREF(tb);
    return result;
}

static int __Pyx_InternStrings(__Pyx_InternTabEntry *t) {
    while (t->p) {
        *t->p = PyString_InternFromString(t->s);
        if (!*t->p)
            return -1;
        ++t;
    }
    return 0;
}

static int __Pyx_InitStrings(__Pyx_StringTabEntry *t) {
    while (t->p) {
        *t->p = PyString_FromStringAndSize(t->s, t->n - 1);
        if (!*t->p)
            return -1;
        ++t;
    }
    return 0;
}

static int __Pyx_SetVtable(PyObject *dict, void *vtable) {
    PyObject *pycobj = 0;
    int result;
    
    pycobj = PyCObject_FromVoidPtr(vtable, 0);
    if (!pycobj)
        goto bad;
    if (PyDict_SetItemString(dict, "__pyx_vtable__", pycobj) < 0)
        goto bad;
    result = 0;
    goto done;

bad:
    result = -1;
done:
    Py_XDECREF(pycobj);
    return result;
}

#include "compile.h"
#include "frameobject.h"
#include "traceback.h"

static void __Pyx_AddTraceback(char *funcname) {
    PyObject *py_srcfile = 0;
    PyObject *py_funcname = 0;
    PyObject *py_globals = 0;
    PyObject *empty_tuple = 0;
    PyObject *empty_string = 0;
    PyCodeObject *py_code = 0;
    PyFrameObject *py_frame = 0;
    
    py_srcfile = PyString_FromString(__pyx_filename);
    if (!py_srcfile) goto bad;
    py_funcname = PyString_FromString(funcname);
    if (!py_funcname) goto bad;
    py_globals = PyModule_GetDict(__pyx_m);
    if (!py_globals) goto bad;
    empty_tuple = PyTuple_New(0);
    if (!empty_tuple) goto bad;
    empty_string = PyString_FromString("");
    if (!empty_string) goto bad;
    py_code = PyCode_New(
        0,            /*int argcount,*/
        0,            /*int nlocals,*/
        0,            /*int stacksize,*/
        0,            /*int flags,*/
        empty_string, /*PyObject *code,*/
        empty_tuple,  /*PyObject *consts,*/
        empty_tuple,  /*PyObject *names,*/
        empty_tuple,  /*PyObject *varnames,*/
        empty_tuple,  /*PyObject *freevars,*/
        empty_tuple,  /*PyObject *cellvars,*/
        py_srcfile,   /*PyObject *filename,*/
        py_funcname,  /*PyObject *name,*/
        __pyx_lineno,   /*int firstlineno,*/
        empty_string  /*PyObject *lnotab*/
    );
    if (!py_code) goto bad;
    py_frame = PyFrame_New(
        PyThreadState_Get(), /*PyThreadState *tstate,*/
        py_code,             /*PyCodeObject *code,*/
        py_globals,          /*PyObject *globals,*/
        0                    /*PyObject *locals*/
    );
    if (!py_frame) goto bad;
    py_frame->f_lineno = __pyx_lineno;
    PyTraceBack_Here(py_frame);
bad:
    Py_XDECREF(py_srcfile);
    Py_XDECREF(py_funcname);
    Py_XDECREF(empty_tuple);
    Py_XDECREF(empty_string);
    Py_XDECREF(py_code);
    Py_XDECREF(py_frame);
}
